#include "utilities/almost_equal.hpp"
#include "basis/bases_2D.hpp"

const std::vector<std::vector<double>> true_vals = {{1.0000000000000000e+00,
                                                     1.0000000000000000e+00,
                                                     1.0000000000000000e+00,
                                                     1.0000000000000000e+00,
                                                     1.0000000000000000e+00,
                                                     1.0000000000000000e+00,
                                                     1.0000000000000000e+00,
                                                     1.0000000000000000e+00,
                                                     1.0000000000000000e+00,
                                                     1.0000000000000000e+00,
                                                     1.0000000000000000e+00,
                                                     1.0000000000000000e+00,
                                                     1.0000000000000000e+00,
                                                     1.0000000000000000e+00,
                                                     1.0000000000000000e+00},
                                                    {-1.0000000000000000e+00,
                                                     -1.0000000000000000e+00,
                                                     -2.5000000000000000e-01,
                                                     -1.0000000000000000e+00,
                                                     -2.5000000000000000e-01,
                                                     5.0000000000000000e-01,
                                                     -1.0000000000000000e+00,
                                                     -2.5000000000000000e-01,
                                                     5.0000000000000000e-01,
                                                     1.2500000000000000e+00,
                                                     -1.0000000000000000e+00,
                                                     -2.5000000000000000e-01,
                                                     5.0000000000000000e-01,
                                                     1.2500000000000000e+00,
                                                     2.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     5.0000000000000000e-01,
                                                     7.5000000000000000e-01,
                                                     0.0000000000000000e+00,
                                                     2.5000000000000000e-01,
                                                     5.0000000000000000e-01,
                                                     -5.0000000000000000e-01,
                                                     -2.5000000000000000e-01,
                                                     0.0000000000000000e+00,
                                                     2.5000000000000000e-01,
                                                     -1.0000000000000000e+00,
                                                     -7.5000000000000000e-01,
                                                     -5.0000000000000000e-01,
                                                     -2.5000000000000000e-01,
                                                     0.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     1.0000000000000000e+00,
                                                     -3.7500000000000000e-01,
                                                     1.0000000000000000e+00,
                                                     -3.7500000000000000e-01,
                                                     -5.0000000000000000e-01,
                                                     1.0000000000000000e+00,
                                                     -3.7500000000000000e-01,
                                                     -5.0000000000000000e-01,
                                                     6.2500000000000000e-01,
                                                     1.0000000000000000e+00,
                                                     -3.7500000000000000e-01,
                                                     -5.0000000000000000e-01,
                                                     6.2500000000000000e-01,
                                                     3.0000000000000000e+00},
                                                    {-1.0000000000000000e+00,
                                                     -5.0000000000000000e-01,
                                                     1.8750000000000000e-01,
                                                     0.0000000000000000e+00,
                                                     6.2500000000000000e-02,
                                                     7.5000000000000000e-01,
                                                     5.0000000000000000e-01,
                                                     -6.2500000000000000e-02,
                                                     0.0000000000000000e+00,
                                                     6.8750000000000000e-01,
                                                     1.0000000000000000e+00,
                                                     -1.8750000000000000e-01,
                                                     -7.5000000000000000e-01,
                                                     -6.8750000000000000e-01,
                                                     0.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     -1.2500000000000000e-01,
                                                     5.6250000000000000e-01,
                                                     -5.0000000000000000e-01,
                                                     -1.8750000000000000e-01,
                                                     2.5000000000000000e-01,
                                                     -1.2500000000000000e-01,
                                                     -1.8750000000000000e-01,
                                                     -1.2500000000000000e-01,
                                                     6.2500000000000000e-02,
                                                     1.0000000000000000e+00,
                                                     5.6250000000000000e-01,
                                                     2.5000000000000000e-01,
                                                     6.2500000000000000e-02,
                                                     0.0000000000000000e+00},
                                                    {-1.0000000000000000e+00,
                                                     -1.0000000000000000e+00,
                                                     4.8437500000000000e-01,
                                                     -1.0000000000000000e+00,
                                                     4.8437500000000000e-01,
                                                     -3.7500000000000000e-01,
                                                     -1.0000000000000000e+00,
                                                     4.8437500000000000e-01,
                                                     -3.7500000000000000e-01,
                                                     -2.9687500000000000e-01,
                                                     -1.0000000000000000e+00,
                                                     4.8437500000000000e-01,
                                                     -3.7500000000000000e-01,
                                                     -2.9687500000000000e-01,
                                                     4.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     5.0000000000000000e-01,
                                                     -5.1562500000000000e-01,
                                                     0.0000000000000000e+00,
                                                     -1.7187500000000000e-01,
                                                     1.2500000000000000e-01,
                                                     -5.0000000000000000e-01,
                                                     1.7187500000000000e-01,
                                                     0.0000000000000000e+00,
                                                     9.5312500000000000e-01,
                                                     -1.0000000000000000e+00,
                                                     5.1562500000000000e-01,
                                                     -1.2500000000000000e-01,
                                                     -9.5312500000000000e-01,
                                                     0.0000000000000000e+00},
                                                    {-1.0000000000000000e+00,
                                                     1.2500000000000000e-01,
                                                     4.2187500000000000e-01,
                                                     5.0000000000000000e-01,
                                                     -1.4062500000000000e-01,
                                                     6.2500000000000000e-01,
                                                     1.2500000000000000e-01,
                                                     -1.4062500000000000e-01,
                                                     -3.1250000000000000e-01,
                                                     2.6562500000000000e-01,
                                                     -1.0000000000000000e+00,
                                                     4.2187500000000000e-01,
                                                     6.2500000000000000e-01,
                                                     2.6562500000000000e-01,
                                                     0.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     -4.3750000000000000e-01,
                                                     4.2187500000000000e-01,
                                                     0.0000000000000000e+00,
                                                     -1.7187500000000000e-01,
                                                     1.2500000000000000e-01,
                                                     4.3750000000000000e-01,
                                                     1.7187500000000000e-01,
                                                     0.0000000000000000e+00,
                                                     1.5625000000000000e-02,
                                                     -1.0000000000000000e+00,
                                                     -4.2187500000000000e-01,
                                                     -1.2500000000000000e-01,
                                                     -1.5625000000000000e-02,
                                                     0.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     1.0000000000000000e+00,
                                                     -1.3281250000000000e-01,
                                                     1.0000000000000000e+00,
                                                     -1.3281250000000000e-01,
                                                     3.7500000000000000e-01,
                                                     1.0000000000000000e+00,
                                                     -1.3281250000000000e-01,
                                                     3.7500000000000000e-01,
                                                     -7.5781250000000000e-01,
                                                     1.0000000000000000e+00,
                                                     -1.3281250000000000e-01,
                                                     3.7500000000000000e-01,
                                                     -7.5781250000000000e-01,
                                                     5.0000000000000000e+00},
                                                    {-1.0000000000000000e+00,
                                                     -5.0000000000000000e-01,
                                                     2.3437500000000000e-01,
                                                     0.0000000000000000e+00,
                                                     7.8125000000000000e-02,
                                                     -5.0000000000000000e-01,
                                                     5.0000000000000000e-01,
                                                     -7.8125000000000000e-02,
                                                     0.0000000000000000e+00,
                                                     7.3437500000000000e-01,
                                                     1.0000000000000000e+00,
                                                     -2.3437500000000000e-01,
                                                     5.0000000000000000e-01,
                                                     -7.3437500000000000e-01,
                                                     0.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     -1.2500000000000000e-01,
                                                     -4.2187500000000000e-01,
                                                     -5.0000000000000000e-01,
                                                     1.4062500000000000e-01,
                                                     5.0000000000000000e-01,
                                                     -1.2500000000000000e-01,
                                                     1.4062500000000000e-01,
                                                     -2.5000000000000000e-01,
                                                     5.7812500000000000e-01,
                                                     1.0000000000000000e+00,
                                                     -4.2187500000000000e-01,
                                                     5.0000000000000000e-01,
                                                     5.7812500000000000e-01,
                                                     0.0000000000000000e+00},
                                                    {-1.0000000000000000e+00,
                                                     4.3750000000000000e-01,
                                                     5.2734375000000000e-01,
                                                     0.0000000000000000e+00,
                                                     -2.1484375000000000e-01,
                                                     4.3750000000000000e-01,
                                                     -4.3750000000000000e-01,
                                                     2.1484375000000000e-01,
                                                     0.0000000000000000e+00,
                                                     8.9843750000000000e-02,
                                                     1.0000000000000000e+00,
                                                     -5.2734375000000000e-01,
                                                     -4.3750000000000000e-01,
                                                     -8.9843750000000000e-02,
                                                     0.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     -2.8906250000000000e-01,
                                                     3.1640625000000000e-01,
                                                     3.7500000000000000e-01,
                                                     3.9062500000000000e-03,
                                                     6.2500000000000000e-02,
                                                     -2.8906250000000000e-01,
                                                     3.9062500000000000e-03,
                                                     2.3437500000000000e-02,
                                                     3.9062500000000000e-03,
                                                     1.0000000000000000e+00,
                                                     3.1640625000000000e-01,
                                                     6.2500000000000000e-02,
                                                     3.9062500000000000e-03,
                                                     0.0000000000000000e+00},
                                                    {-1.0000000000000000e+00,
                                                     -1.0000000000000000e+00,
                                                     -2.7539062500000000e-01,
                                                     -1.0000000000000000e+00,
                                                     -2.7539062500000000e-01,
                                                     3.1250000000000000e-01,
                                                     -1.0000000000000000e+00,
                                                     -2.7539062500000000e-01,
                                                     3.1250000000000000e-01,
                                                     -4.6679687500000000e-01,
                                                     -1.0000000000000000e+00,
                                                     -2.7539062500000000e-01,
                                                     3.1250000000000000e-01,
                                                     -4.6679687500000000e-01,
                                                     6.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     5.0000000000000000e-01,
                                                     2.1679687500000000e-01,
                                                     0.0000000000000000e+00,
                                                     7.2265625000000000e-02,
                                                     -1.8750000000000000e-01,
                                                     -5.0000000000000000e-01,
                                                     -7.2265625000000000e-02,
                                                     0.0000000000000000e+00,
                                                     1.0351562500000000e-01,
                                                     -1.0000000000000000e+00,
                                                     -2.1679687500000000e-01,
                                                     1.8750000000000000e-01,
                                                     -1.0351562500000000e-01,
                                                     0.0000000000000000e+00},
                                                    {-1.0000000000000000e+00,
                                                     1.2500000000000000e-01,
                                                     -6.1523437500000000e-02,
                                                     5.0000000000000000e-01,
                                                     2.0507812500000000e-02,
                                                     -1.5625000000000000e-01,
                                                     1.2500000000000000e-01,
                                                     2.0507812500000000e-02,
                                                     7.8125000000000000e-02,
                                                     8.0761718750000000e-01,
                                                     -1.0000000000000000e+00,
                                                     -6.1523437500000000e-02,
                                                     -1.5625000000000000e-01,
                                                     8.0761718750000000e-01,
                                                     0.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     -4.3750000000000000e-01,
                                                     -2.3730468750000000e-01,
                                                     0.0000000000000000e+00,
                                                     9.6679687500000000e-02,
                                                     5.9375000000000000e-01,
                                                     4.3750000000000000e-01,
                                                     -9.6679687500000000e-02,
                                                     0.0000000000000000e+00,
                                                     2.6464843750000000e-01,
                                                     -1.0000000000000000e+00,
                                                     2.3730468750000000e-01,
                                                     -5.9375000000000000e-01,
                                                     -2.6464843750000000e-01,
                                                     0.0000000000000000e+00},
                                                    {-1.0000000000000000e+00,
                                                     2.8906250000000000e-01,
                                                     5.5371093750000000e-01,
                                                     -3.7500000000000000e-01,
                                                     6.8359375000000000e-03,
                                                     2.8125000000000000e-01,
                                                     2.8906250000000000e-01,
                                                     6.8359375000000000e-03,
                                                     1.0546875000000000e-01,
                                                     2.8320312500000000e-02,
                                                     -1.0000000000000000e+00,
                                                     5.5371093750000000e-01,
                                                     2.8125000000000000e-01,
                                                     2.8320312500000000e-02,
                                                     0.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     8.9843750000000000e-02,
                                                     2.3730468750000000e-01,
                                                     0.0000000000000000e+00,
                                                     7.9101562500000000e-02,
                                                     3.1250000000000000e-02,
                                                     -8.9843750000000000e-02,
                                                     -7.9101562500000000e-02,
                                                     0.0000000000000000e+00,
                                                     9.7656250000000000e-04,
                                                     -1.0000000000000000e+00,
                                                     -2.3730468750000000e-01,
                                                     -3.1250000000000000e-02,
                                                     -9.7656250000000000e-04,
                                                     0.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     1.0000000000000000e+00,
                                                     3.6425781250000000e-01,
                                                     1.0000000000000000e+00,
                                                     3.6425781250000000e-01,
                                                     -3.1250000000000000e-01,
                                                     1.0000000000000000e+00,
                                                     3.6425781250000000e-01,
                                                     -3.1250000000000000e-01,
                                                     2.0019531250000000e-01,
                                                     1.0000000000000000e+00,
                                                     3.6425781250000000e-01,
                                                     -3.1250000000000000e-01,
                                                     2.0019531250000000e-01,
                                                     7.0000000000000000e+00},
                                                    {-1.0000000000000000e+00,
                                                     -5.0000000000000000e-01,
                                                     -3.7866210937500000e-01,
                                                     0.0000000000000000e+00,
                                                     -1.2622070312500000e-01,
                                                     3.9062500000000000e-01,
                                                     5.0000000000000000e-01,
                                                     1.2622070312500000e-01,
                                                     0.0000000000000000e+00,
                                                     -4.9389648437500000e-01,
                                                     1.0000000000000000e+00,
                                                     3.7866210937500000e-01,
                                                     -3.9062500000000000e-01,
                                                     4.9389648437500000e-01,
                                                     0.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     -1.2500000000000000e-01,
                                                     3.7573242187500000e-01,
                                                     -5.0000000000000000e-01,
                                                     -1.2524414062500000e-01,
                                                     -4.5312500000000000e-01,
                                                     -1.2500000000000000e-01,
                                                     -1.2524414062500000e-01,
                                                     2.2656250000000000e-01,
                                                     7.2534179687500000e-01,
                                                     1.0000000000000000e+00,
                                                     3.7573242187500000e-01,
                                                     -4.5312500000000000e-01,
                                                     7.2534179687500000e-01,
                                                     0.0000000000000000e+00},
                                                    {-1.0000000000000000e+00,
                                                     4.3750000000000000e-01,
                                                     -2.7685546875000000e-01,
                                                     0.0000000000000000e+00,
                                                     1.1279296875000000e-01,
                                                     2.1875000000000000e-01,
                                                     -4.3750000000000000e-01,
                                                     -1.1279296875000000e-01,
                                                     0.0000000000000000e+00,
                                                     5.1611328125000000e-01,
                                                     1.0000000000000000e+00,
                                                     2.7685546875000000e-01,
                                                     -2.1875000000000000e-01,
                                                     -5.1611328125000000e-01,
                                                     0.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     -2.8906250000000000e-01,
                                                     -3.9550781250000000e-02,
                                                     3.7500000000000000e-01,
                                                     -4.8828125000000000e-04,
                                                     5.3125000000000000e-01,
                                                     -2.8906250000000000e-01,
                                                     -4.8828125000000000e-04,
                                                     1.9921875000000000e-01,
                                                     1.0498046875000000e-01,
                                                     1.0000000000000000e+00,
                                                     -3.9550781250000000e-02,
                                                     5.3125000000000000e-01,
                                                     1.0498046875000000e-01,
                                                     0.0000000000000000e+00},
                                                    {-1.0000000000000000e+00,
                                                     -8.9843750000000000e-02,
                                                     5.3393554687500000e-01,
                                                     0.0000000000000000e+00,
                                                     1.7797851562500000e-01,
                                                     1.7187500000000000e-01,
                                                     8.9843750000000000e-02,
                                                     -1.7797851562500000e-01,
                                                     0.0000000000000000e+00,
                                                     8.5449218750000000e-03,
                                                     1.0000000000000000e+00,
                                                     -5.3393554687500000e-01,
                                                     -1.7187500000000000e-01,
                                                     -8.5449218750000000e-03,
                                                     0.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     3.2324218750000000e-01,
                                                     1.7797851562500000e-01,
                                                     -3.1250000000000000e-01,
                                                     3.4423828125000000e-02,
                                                     1.5625000000000000e-02,
                                                     3.2324218750000000e-01,
                                                     3.4423828125000000e-02,
                                                     -4.8828125000000000e-03,
                                                     2.4414062500000000e-04,
                                                     1.0000000000000000e+00,
                                                     1.7797851562500000e-01,
                                                     1.5625000000000000e-02,
                                                     2.4414062500000000e-04,
                                                     0.0000000000000000e+00},
                                                    {-1.0000000000000000e+00,
                                                     -1.0000000000000000e+00,
                                                     -9.9670410156250000e-02,
                                                     -1.0000000000000000e+00,
                                                     -9.9670410156250000e-02,
                                                     -2.7343750000000000e-01,
                                                     -1.0000000000000000e+00,
                                                     -9.9670410156250000e-02,
                                                     -2.7343750000000000e-01,
                                                     5.9356689453125000e-01,
                                                     -1.0000000000000000e+00,
                                                     -9.9670410156250000e-02,
                                                     -2.7343750000000000e-01,
                                                     5.9356689453125000e-01,
                                                     8.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     5.0000000000000000e-01,
                                                     1.4886474609375000e-01,
                                                     0.0000000000000000e+00,
                                                     4.9621582031250000e-02,
                                                     1.9531250000000000e-01,
                                                     -5.0000000000000000e-01,
                                                     -4.9621582031250000e-02,
                                                     0.0000000000000000e+00,
                                                     -6.1297607421875000e-01,
                                                     -1.0000000000000000e+00,
                                                     -1.4886474609375000e-01,
                                                     -1.9531250000000000e-01,
                                                     6.1297607421875000e-01,
                                                     0.0000000000000000e+00},
                                                    {-1.0000000000000000e+00,
                                                     1.2500000000000000e-01,
                                                     -2.4224853515625000e-01,
                                                     5.0000000000000000e-01,
                                                     8.0749511718750000e-02,
                                                     7.8125000000000000e-03,
                                                     1.2500000000000000e-01,
                                                     8.0749511718750000e-02,
                                                     -3.9062500000000000e-03,
                                                     2.8594970703125000e-01,
                                                     -1.0000000000000000e+00,
                                                     -2.4224853515625000e-01,
                                                     7.8125000000000000e-03,
                                                     2.8594970703125000e-01,
                                                     0.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     -4.3750000000000000e-01,
                                                     3.5101318359375000e-01,
                                                     0.0000000000000000e+00,
                                                     -1.4300537109375000e-01,
                                                     -3.3593750000000000e-01,
                                                     4.3750000000000000e-01,
                                                     1.4300537109375000e-01,
                                                     0.0000000000000000e+00,
                                                     7.1710205078125000e-01,
                                                     -1.0000000000000000e+00,
                                                     -3.5101318359375000e-01,
                                                     3.3593750000000000e-01,
                                                     -7.1710205078125000e-01,
                                                     0.0000000000000000e+00},
                                                    {-1.0000000000000000e+00,
                                                     2.8906250000000000e-01,
                                                     -3.8067626953125000e-01,
                                                     -3.7500000000000000e-01,
                                                     -4.6997070312500000e-03,
                                                     4.4531250000000000e-01,
                                                     2.8906250000000000e-01,
                                                     -4.6997070312500000e-03,
                                                     1.6699218750000000e-01,
                                                     2.6031494140625000e-01,
                                                     -1.0000000000000000e+00,
                                                     -3.8067626953125000e-01,
                                                     4.4531250000000000e-01,
                                                     2.6031494140625000e-01,
                                                     0.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     8.9843750000000000e-02,
                                                     1.3348388671875000e-01,
                                                     0.0000000000000000e+00,
                                                     4.4494628906250000e-02,
                                                     4.1406250000000000e-01,
                                                     -8.9843750000000000e-02,
                                                     -4.4494628906250000e-02,
                                                     0.0000000000000000e+00,
                                                     3.8146972656250000e-02,
                                                     -1.0000000000000000e+00,
                                                     -1.3348388671875000e-01,
                                                     -4.1406250000000000e-01,
                                                     -3.8146972656250000e-02,
                                                     0.0000000000000000e+00},
                                                    {-1.0000000000000000e+00,
                                                     -3.2324218750000000e-01,
                                                     4.8944091796875000e-01,
                                                     3.1250000000000000e-01,
                                                     9.4665527343750000e-02,
                                                     1.0156250000000000e-01,
                                                     -3.2324218750000000e-01,
                                                     9.4665527343750000e-02,
                                                     -3.1738281250000000e-02,
                                                     2.5024414062500000e-03,
                                                     -1.0000000000000000e+00,
                                                     4.8944091796875000e-01,
                                                     1.0156250000000000e-01,
                                                     2.5024414062500000e-03,
                                                     0.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     2.2314453125000000e-01,
                                                     1.3348388671875000e-01,
                                                     0.0000000000000000e+00,
                                                     -2.2155761718750000e-02,
                                                     7.8125000000000000e-03,
                                                     -2.2314453125000000e-01,
                                                     2.2155761718750000e-02,
                                                     0.0000000000000000e+00,
                                                     6.1035156250000000e-05,
                                                     -1.0000000000000000e+00,
                                                     -1.3348388671875000e-01,
                                                     -7.8125000000000000e-03,
                                                     -6.1035156250000000e-05,
                                                     0.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     1.0000000000000000e+00,
                                                     -2.2769165039062500e-01,
                                                     1.0000000000000000e+00,
                                                     -2.2769165039062500e-01,
                                                     2.7343750000000000e-01,
                                                     1.0000000000000000e+00,
                                                     -2.2769165039062500e-01,
                                                     2.7343750000000000e-01,
                                                     3.8851928710937500e-01,
                                                     1.0000000000000000e+00,
                                                     -2.2769165039062500e-01,
                                                     2.7343750000000000e-01,
                                                     3.8851928710937500e-01,
                                                     9.0000000000000000e+00},
                                                    {-1.0000000000000000e+00,
                                                     -5.0000000000000000e-01,
                                                     1.9665527343750000e-01,
                                                     0.0000000000000000e+00,
                                                     6.5551757812500000e-02,
                                                     -3.2812500000000000e-01,
                                                     5.0000000000000000e-01,
                                                     -6.5551757812500000e-02,
                                                     0.0000000000000000e+00,
                                                     -2.0568847656250000e-01,
                                                     1.0000000000000000e+00,
                                                     -1.9665527343750000e-01,
                                                     3.2812500000000000e-01,
                                                     2.0568847656250000e-01,
                                                     0.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     -1.2500000000000000e-01,
                                                     -1.2194824218750000e-01,
                                                     -5.0000000000000000e-01,
                                                     4.0649414062500000e-02,
                                                     3.9062500000000000e-01,
                                                     -1.2500000000000000e-01,
                                                     4.0649414062500000e-02,
                                                     -1.9531250000000000e-01,
                                                     -2.7038574218750000e-01,
                                                     1.0000000000000000e+00,
                                                     -1.2194824218750000e-01,
                                                     3.9062500000000000e-01,
                                                     -2.7038574218750000e-01,
                                                     0.0000000000000000e+00},
                                                    {-1.0000000000000000e+00,
                                                     4.3750000000000000e-01,
                                                     -1.4831542968750000e-02,
                                                     0.0000000000000000e+00,
                                                     6.0424804687500000e-03,
                                                     -3.2812500000000000e-01,
                                                     -4.3750000000000000e-01,
                                                     -6.0424804687500000e-03,
                                                     0.0000000000000000e+00,
                                                     6.9610595703125000e-01,
                                                     1.0000000000000000e+00,
                                                     1.4831542968750000e-02,
                                                     3.2812500000000000e-01,
                                                     -6.9610595703125000e-01,
                                                     0.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     -2.8906250000000000e-01,
                                                     2.1258544921875000e-01,
                                                     3.7500000000000000e-01,
                                                     2.6245117187500000e-03,
                                                     -4.6875000000000000e-02,
                                                     -2.8906250000000000e-01,
                                                     2.6245117187500000e-03,
                                                     -1.7578125000000000e-02,
                                                     4.7430419921875000e-01,
                                                     1.0000000000000000e+00,
                                                     2.1258544921875000e-01,
                                                     -4.6875000000000000e-02,
                                                     4.7430419921875000e-01,
                                                     0.0000000000000000e+00},
                                                    {-1.0000000000000000e+00,
                                                     -8.9843750000000000e-02,
                                                     -3.8562011718750000e-01,
                                                     0.0000000000000000e+00,
                                                     -1.2854003906250000e-01,
                                                     5.1562500000000000e-01,
                                                     8.9843750000000000e-02,
                                                     1.2854003906250000e-01,
                                                     0.0000000000000000e+00,
                                                     1.1437988281250000e-01,
                                                     1.0000000000000000e+00,
                                                     3.8562011718750000e-01,
                                                     -5.1562500000000000e-01,
                                                     -1.1437988281250000e-01,
                                                     0.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     3.2324218750000000e-01,
                                                     2.6696777343750000e-01,
                                                     -3.1250000000000000e-01,
                                                     5.1635742187500000e-02,
                                                     2.9687500000000000e-01,
                                                     3.2324218750000000e-01,
                                                     5.1635742187500000e-02,
                                                     -9.2773437500000000e-02,
                                                     1.3061523437500000e-02,
                                                     1.0000000000000000e+00,
                                                     2.6696777343750000e-01,
                                                     2.9687500000000000e-01,
                                                     1.3061523437500000e-02,
                                                     0.0000000000000000e+00},
                                                    {-1.0000000000000000e+00,
                                                     -2.2314453125000000e-01,
                                                     4.3382263183593750e-01,
                                                     0.0000000000000000e+00,
                                                     -7.2006225585937500e-02,
                                                     5.8593750000000000e-02,
                                                     2.2314453125000000e-01,
                                                     7.2006225585937500e-02,
                                                     0.0000000000000000e+00,
                                                     7.1716308593750000e-04,
                                                     1.0000000000000000e+00,
                                                     -4.3382263183593750e-01,
                                                     -5.8593750000000000e-02,
                                                     -7.1716308593750000e-04,
                                                     0.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     -7.3638916015625000e-02,
                                                     1.0011291503906250e-01,
                                                     2.7343750000000000e-01,
                                                     -2.7328491210937500e-02,
                                                     3.9062500000000000e-03,
                                                     -7.3638916015625000e-02,
                                                     -2.7328491210937500e-02,
                                                     1.0681152343750000e-03,
                                                     1.5258789062500000e-05,
                                                     1.0000000000000000e+00,
                                                     1.0011291503906250e-01,
                                                     3.9062500000000000e-03,
                                                     1.5258789062500000e-05,
                                                     0.0000000000000000e+00},
                                                    {-1.0000000000000000e+00,
                                                     -1.0000000000000000e+00,
                                                     3.0408477783203125e-01,
                                                     -1.0000000000000000e+00,
                                                     3.0408477783203125e-01,
                                                     2.4609375000000000e-01,
                                                     -1.0000000000000000e+00,
                                                     3.0408477783203125e-01,
                                                     2.4609375000000000e-01,
                                                     -1.5933990478515625e-01,
                                                     -1.0000000000000000e+00,
                                                     3.0408477783203125e-01,
                                                     2.4609375000000000e-01,
                                                     -1.5933990478515625e-01,
                                                     1.0000000000000000e+01},
                                                    {1.0000000000000000e+00,
                                                     5.0000000000000000e-01,
                                                     -3.1276702880859375e-01,
                                                     0.0000000000000000e+00,
                                                     -1.0425567626953125e-01,
                                                     -1.9140625000000000e-01,
                                                     -5.0000000000000000e-01,
                                                     1.0425567626953125e-01,
                                                     0.0000000000000000e+00,
                                                     3.3397674560546875e-01,
                                                     -1.0000000000000000e+00,
                                                     3.1276702880859375e-01,
                                                     1.9140625000000000e-01,
                                                     -3.3397674560546875e-01,
                                                     0.0000000000000000e+00},
                                                    {-1.0000000000000000e+00,
                                                     1.2500000000000000e-01,
                                                     3.1764221191406250e-01,
                                                     5.0000000000000000e-01,
                                                     -1.0588073730468750e-01,
                                                     5.4687500000000000e-02,
                                                     1.2500000000000000e-01,
                                                     -1.0588073730468750e-01,
                                                     -2.7343750000000000e-02,
                                                     -5.6892395019531250e-01,
                                                     -1.0000000000000000e+00,
                                                     3.1764221191406250e-01,
                                                     5.4687500000000000e-02,
                                                     -5.6892395019531250e-01,
                                                     0.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     -4.3750000000000000e-01,
                                                     -2.9045104980468750e-01,
                                                     0.0000000000000000e+00,
                                                     1.1833190917968750e-01,
                                                     1.7968750000000000e-01,
                                                     4.3750000000000000e-01,
                                                     -1.1833190917968750e-01,
                                                     0.0000000000000000e+00,
                                                     3.7803649902343750e-01,
                                                     -1.0000000000000000e+00,
                                                     2.9045104980468750e-01,
                                                     -1.7968750000000000e-01,
                                                     -3.7803649902343750e-01,
                                                     0.0000000000000000e+00},
                                                    {-1.0000000000000000e+00,
                                                     2.8906250000000000e-01,
                                                     1.8663024902343750e-01,
                                                     -3.7500000000000000e-01,
                                                     2.3040771484375000e-03,
                                                     -3.9843750000000000e-01,
                                                     2.8906250000000000e-01,
                                                     2.3040771484375000e-03,
                                                     -1.4941406250000000e-01,
                                                     6.5376281738281250e-01,
                                                     -1.0000000000000000e+00,
                                                     1.8663024902343750e-01,
                                                     -3.9843750000000000e-01,
                                                     6.5376281738281250e-01,
                                                     0.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     8.9843750000000000e-02,
                                                     3.3370971679687500e-02,
                                                     0.0000000000000000e+00,
                                                     1.1123657226562500e-02,
                                                     2.2656250000000000e-01,
                                                     -8.9843750000000000e-02,
                                                     -1.1123657226562500e-02,
                                                     0.0000000000000000e+00,
                                                     2.5526428222656250e-01,
                                                     -1.0000000000000000e+00,
                                                     -3.3370971679687500e-02,
                                                     -2.2656250000000000e-01,
                                                     -2.5526428222656250e-01,
                                                     0.0000000000000000e+00},
                                                    {-1.0000000000000000e+00,
                                                     -3.2324218750000000e-01,
                                                     -3.1980514526367188e-01,
                                                     3.1250000000000000e-01,
                                                     -6.1855316162109375e-02,
                                                     4.8242187500000000e-01,
                                                     -3.2324218750000000e-01,
                                                     -6.1855316162109375e-02,
                                                     -1.5075683593750000e-01,
                                                     4.5864105224609375e-02,
                                                     -1.0000000000000000e+00,
                                                     -3.1980514526367188e-01,
                                                     4.8242187500000000e-01,
                                                     4.5864105224609375e-02,
                                                     0.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     2.2314453125000000e-01,
                                                     3.5873794555664062e-01,
                                                     0.0000000000000000e+00,
                                                     -5.9543609619140625e-02,
                                                     2.0117187500000000e-01,
                                                     -2.2314453125000000e-01,
                                                     5.9543609619140625e-02,
                                                     0.0000000000000000e+00,
                                                     4.2839050292968750e-03,
                                                     -1.0000000000000000e+00,
                                                     -3.5873794555664062e-01,
                                                     -2.0117187500000000e-01,
                                                     -4.2839050292968750e-03,
                                                     0.0000000000000000e+00},
                                                    {-1.0000000000000000e+00,
                                                     7.3638916015625000e-02,
                                                     3.7542343139648438e-01,
                                                     -2.7343750000000000e-01,
                                                     -1.0248184204101562e-01,
                                                     3.3203125000000000e-02,
                                                     7.3638916015625000e-02,
                                                     -1.0248184204101562e-01,
                                                     9.0789794921875000e-03,
                                                     2.0217895507812500e-04,
                                                     -1.0000000000000000e+00,
                                                     3.7542343139648438e-01,
                                                     3.3203125000000000e-02,
                                                     2.0217895507812500e-04,
                                                     0.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     -2.6789855957031250e-01,
                                                     7.5084686279296875e-02,
                                                     0.0000000000000000e+00,
                                                     -1.8272399902343750e-03,
                                                     1.9531250000000000e-03,
                                                     2.6789855957031250e-01,
                                                     1.8272399902343750e-03,
                                                     0.0000000000000000e+00,
                                                     3.8146972656250000e-06,
                                                     -1.0000000000000000e+00,
                                                     -7.5084686279296875e-02,
                                                     -1.9531250000000000e-03,
                                                     -3.8146972656250000e-06,
                                                     0.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     1.0000000000000000e+00,
                                                     -8.2904815673828125e-02,
                                                     1.0000000000000000e+00,
                                                     -8.2904815673828125e-02,
                                                     -2.4609375000000000e-01,
                                                     1.0000000000000000e+00,
                                                     -8.2904815673828125e-02,
                                                     -2.4609375000000000e-01,
                                                     -5.0419998168945312e-01,
                                                     1.0000000000000000e+00,
                                                     -8.2904815673828125e-02,
                                                     -2.4609375000000000e-01,
                                                     -5.0419998168945312e-01,
                                                     1.1000000000000000e+01},
                                                    {-1.0000000000000000e+00,
                                                     -5.0000000000000000e-01,
                                                     1.1325645446777344e-01,
                                                     0.0000000000000000e+00,
                                                     3.7752151489257812e-02,
                                                     2.8710937500000000e-01,
                                                     5.0000000000000000e-01,
                                                     -3.7752151489257812e-02,
                                                     0.0000000000000000e+00,
                                                     5.2458763122558594e-01,
                                                     1.0000000000000000e+00,
                                                     -1.1325645446777344e-01,
                                                     -2.8710937500000000e-01,
                                                     -5.2458763122558594e-01,
                                                     0.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     -1.2500000000000000e-01,
                                                     -1.7164421081542969e-01,
                                                     -5.0000000000000000e-01,
                                                     5.7214736938476562e-02,
                                                     -3.4179687500000000e-01,
                                                     -1.2500000000000000e-01,
                                                     5.7214736938476562e-02,
                                                     1.7089843750000000e-01,
                                                     -4.0499687194824219e-01,
                                                     1.0000000000000000e+00,
                                                     -1.7164421081542969e-01,
                                                     -3.4179687500000000e-01,
                                                     -4.0499687194824219e-01,
                                                     0.0000000000000000e+00},
                                                    {-1.0000000000000000e+00,
                                                     4.3750000000000000e-01,
                                                     2.4781036376953125e-01,
                                                     0.0000000000000000e+00,
                                                     -1.0095977783203125e-01,
                                                     3.3593750000000000e-01,
                                                     -4.3750000000000000e-01,
                                                     1.0095977783203125e-01,
                                                     0.0000000000000000e+00,
                                                     -1.0784149169921875e-01,
                                                     1.0000000000000000e+00,
                                                     -2.4781036376953125e-01,
                                                     -3.3593750000000000e-01,
                                                     1.0784149169921875e-01,
                                                     0.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     -2.8906250000000000e-01,
                                                     -3.1208038330078125e-01,
                                                     3.7500000000000000e-01,
                                                     -3.8528442382812500e-03,
                                                     -1.4843750000000000e-01,
                                                     -2.8906250000000000e-01,
                                                     -3.8528442382812500e-03,
                                                     -5.5664062500000000e-02,
                                                     6.6466522216796875e-01,
                                                     1.0000000000000000e+00,
                                                     -3.1208038330078125e-01,
                                                     -1.4843750000000000e-01,
                                                     6.6466522216796875e-01,
                                                     0.0000000000000000e+00},
                                                    {-1.0000000000000000e+00,
                                                     -8.9843750000000000e-02,
                                                     3.0242443084716797e-01,
                                                     0.0000000000000000e+00,
                                                     1.0080814361572266e-01,
                                                     -2.4707031250000000e-01,
                                                     8.9843750000000000e-02,
                                                     -1.0080814361572266e-01,
                                                     0.0000000000000000e+00,
                                                     4.4342327117919922e-01,
                                                     1.0000000000000000e+00,
                                                     -3.0242443084716797e-01,
                                                     2.4707031250000000e-01,
                                                     -4.4342327117919922e-01,
                                                     0.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     3.2324218750000000e-01,
                                                     -1.3278865814208984e-01,
                                                     -3.1250000000000000e-01,
                                                     -2.5683403015136719e-02,
                                                     3.9941406250000000e-01,
                                                     3.2324218750000000e-01,
                                                     -2.5683403015136719e-02,
                                                     -1.2481689453125000e-01,
                                                     1.2062168121337891e-01,
                                                     1.0000000000000000e+00,
                                                     -1.3278865814208984e-01,
                                                     3.9941406250000000e-01,
                                                     1.2062168121337891e-01,
                                                     0.0000000000000000e+00},
                                                    {-1.0000000000000000e+00,
                                                     -2.2314453125000000e-01,
                                                     -2.1273994445800781e-01,
                                                     0.0000000000000000e+00,
                                                     3.5310745239257812e-02,
                                                     4.0039062500000000e-01,
                                                     2.2314453125000000e-01,
                                                     -3.5310745239257812e-02,
                                                     0.0000000000000000e+00,
                                                     1.7225265502929688e-02,
                                                     1.0000000000000000e+00,
                                                     2.1273994445800781e-01,
                                                     -4.0039062500000000e-01,
                                                     -1.7225265502929688e-02,
                                                     0.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     -7.3638916015625000e-02,
                                                     4.1296577453613281e-01,
                                                     2.7343750000000000e-01,
                                                     -1.1273002624511719e-01,
                                                     1.3085937500000000e-01,
                                                     -7.3638916015625000e-02,
                                                     -1.1273002624511719e-01,
                                                     3.5781860351562500e-02,
                                                     1.3599395751953125e-03,
                                                     1.0000000000000000e+00,
                                                     4.1296577453613281e-01,
                                                     1.3085937500000000e-01,
                                                     1.3599395751953125e-03,
                                                     0.0000000000000000e+00},
                                                    {-1.0000000000000000e+00,
                                                     2.6789855957031250e-01,
                                                     3.1910991668701172e-01,
                                                     0.0000000000000000e+00,
                                                     -7.7657699584960938e-03,
                                                     1.8554687500000000e-02,
                                                     -2.6789855957031250e-01,
                                                     7.7657699584960938e-03,
                                                     0.0000000000000000e+00,
                                                     5.6266784667968750e-05,
                                                     1.0000000000000000e+00,
                                                     -3.1910991668701172e-01,
                                                     -1.8554687500000000e-02,
                                                     -5.6266784667968750e-05,
                                                     0.0000000000000000e+00},
                                                    {1.0000000000000000e+00,
                                                     -1.8822860717773438e-01,
                                                     5.6313514709472656e-02,
                                                     -2.4609375000000000e-01,
                                                     1.2967109680175781e-02,
                                                     9.7656250000000000e-04,
                                                     -1.8822860717773438e-01,
                                                     1.2967109680175781e-02,
                                                     -2.4032592773437500e-04,
                                                     9.5367431640625000e-07,
                                                     1.0000000000000000e+00,
                                                     5.6313514709472656e-02,
                                                     9.7656250000000000e-04,
                                                     9.5367431640625000e-07,
                                                     0.0000000000000000e+00}};

const std::vector<std::vector<double>> true_Dvals = {
    {0.0000000000000000e+00, 0.0000000000000000e+00, 0.0000000000000000e+00, 0.0000000000000000e+00,
     0.0000000000000000e+00, 0.0000000000000000e+00, 0.0000000000000000e+00, 0.0000000000000000e+00,
     0.0000000000000000e+00, 0.0000000000000000e+00, 0.0000000000000000e+00, 0.0000000000000000e+00,
     0.0000000000000000e+00, 0.0000000000000000e+00, 0.0000000000000000e+00, 0.0000000000000000e+00,
     0.0000000000000000e+00, 0.0000000000000000e+00, 0.0000000000000000e+00, 0.0000000000000000e+00,
     0.0000000000000000e+00, 0.0000000000000000e+00, 0.0000000000000000e+00, 0.0000000000000000e+00,
     0.0000000000000000e+00, 0.0000000000000000e+00, 0.0000000000000000e+00, 0.0000000000000000e+00,
     0.0000000000000000e+00, 0.0000000000000000e+00},
    {0.0000000000000000e+00, 1.5000000000000000e+00, 0.0000000000000000e+00, 1.5000000000000000e+00,
     0.0000000000000000e+00, 1.5000000000000000e+00, 0.0000000000000000e+00, 1.5000000000000000e+00,
     0.0000000000000000e+00, 1.5000000000000000e+00, 0.0000000000000000e+00, 1.5000000000000000e+00,
     0.0000000000000000e+00, 1.5000000000000000e+00, 0.0000000000000000e+00, 1.5000000000000000e+00,
     0.0000000000000000e+00, 1.5000000000000000e+00, 0.0000000000000000e+00, 1.5000000000000000e+00,
     0.0000000000000000e+00, 1.5000000000000000e+00, 0.0000000000000000e+00, 1.5000000000000000e+00,
     0.0000000000000000e+00, 1.5000000000000000e+00, 0.0000000000000000e+00, 1.5000000000000000e+00,
     0.0000000000000000e+00, 1.5000000000000000e+00},
    {1.0000000000000000e+00, 5.0000000000000000e-01, 1.0000000000000000e+00, 5.0000000000000000e-01,
     1.0000000000000000e+00, 5.0000000000000000e-01, 1.0000000000000000e+00, 5.0000000000000000e-01,
     1.0000000000000000e+00, 5.0000000000000000e-01, 1.0000000000000000e+00, 5.0000000000000000e-01,
     1.0000000000000000e+00, 5.0000000000000000e-01, 1.0000000000000000e+00, 5.0000000000000000e-01,
     1.0000000000000000e+00, 5.0000000000000000e-01, 1.0000000000000000e+00, 5.0000000000000000e-01,
     1.0000000000000000e+00, 5.0000000000000000e-01, 1.0000000000000000e+00, 5.0000000000000000e-01,
     1.0000000000000000e+00, 5.0000000000000000e-01, 1.0000000000000000e+00, 5.0000000000000000e-01,
     1.0000000000000000e+00, 5.0000000000000000e-01},
    {0.0000000000000000e+00, -4.0000000000000000e+00, 0.0000000000000000e+00, -4.0000000000000000e+00,
     0.0000000000000000e+00, -1.5000000000000000e+00, 0.0000000000000000e+00, -4.0000000000000000e+00,
     0.0000000000000000e+00, -1.5000000000000000e+00, 0.0000000000000000e+00, 1.0000000000000000e+00,
     0.0000000000000000e+00, -4.0000000000000000e+00, 0.0000000000000000e+00, -1.5000000000000000e+00,
     0.0000000000000000e+00, 1.0000000000000000e+00,  0.0000000000000000e+00, 3.5000000000000000e+00,
     0.0000000000000000e+00, -4.0000000000000000e+00, 0.0000000000000000e+00, -1.5000000000000000e+00,
     0.0000000000000000e+00, 1.0000000000000000e+00,  0.0000000000000000e+00, 3.5000000000000000e+00,
     0.0000000000000000e+00, 6.0000000000000000e+00},
    {-1.0000000000000000e+00, 2.0000000000000000e+00,  -1.0000000000000000e+00, 7.5000000000000000e-01,
     2.5000000000000000e-01,  2.0000000000000000e+00,  -1.0000000000000000e+00, -5.0000000000000000e-01,
     2.5000000000000000e-01,  7.5000000000000000e-01,  1.5000000000000000e+00,  2.0000000000000000e+00,
     -1.0000000000000000e+00, -1.7500000000000000e+00, 2.5000000000000000e-01,  -5.0000000000000000e-01,
     1.5000000000000000e+00,  7.5000000000000000e-01,  2.7500000000000000e+00,  2.0000000000000000e+00,
     -1.0000000000000000e+00, -3.0000000000000000e+00, 2.5000000000000000e-01,  -1.7500000000000000e+00,
     1.5000000000000000e+00,  -5.0000000000000000e-01, 2.7500000000000000e+00,  7.5000000000000000e-01,
     4.0000000000000000e+00,  2.0000000000000000e+00},
    {3.0000000000000000e+00,  2.0000000000000000e+00,  1.5000000000000000e+00,  1.2500000000000000e+00,
     2.2500000000000000e+00,  1.5000000000000000e+00,  0.0000000000000000e+00,  5.0000000000000000e-01,
     7.5000000000000000e-01,  7.5000000000000000e-01,  1.5000000000000000e+00,  1.0000000000000000e+00,
     -1.5000000000000000e+00, -2.5000000000000000e-01, -7.5000000000000000e-01, 0.0000000000000000e+00,
     0.0000000000000000e+00,  2.5000000000000000e-01,  7.5000000000000000e-01,  5.0000000000000000e-01,
     -3.0000000000000000e+00, -1.0000000000000000e+00, -2.2500000000000000e+00, -7.5000000000000000e-01,
     -1.5000000000000000e+00, -5.0000000000000000e-01, -7.5000000000000000e-01, -2.5000000000000000e-01,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {0.0000000000000000e+00, 7.5000000000000000e+00,  0.0000000000000000e+00, 7.5000000000000000e+00,
     0.0000000000000000e+00, -4.6875000000000000e-01, 0.0000000000000000e+00, 7.5000000000000000e+00,
     0.0000000000000000e+00, -4.6875000000000000e-01, 0.0000000000000000e+00, -1.8750000000000000e+00,
     0.0000000000000000e+00, 7.5000000000000000e+00,  0.0000000000000000e+00, -4.6875000000000000e-01,
     0.0000000000000000e+00, -1.8750000000000000e+00, 0.0000000000000000e+00, 3.2812500000000000e+00,
     0.0000000000000000e+00, 7.5000000000000000e+00,  0.0000000000000000e+00, -4.6875000000000000e-01,
     0.0000000000000000e+00, -1.8750000000000000e+00, 0.0000000000000000e+00, 3.2812500000000000e+00,
     0.0000000000000000e+00, 1.5000000000000000e+01},
    {1.0000000000000000e+00,  -5.5000000000000000e+00, 1.0000000000000000e+00,  -2.5000000000000000e+00,
     -6.8750000000000000e-01, -9.0625000000000000e-01, 1.0000000000000000e+00,  5.0000000000000000e-01,
     -6.8750000000000000e-01, -5.3125000000000000e-01, 2.5000000000000000e-01,  2.3750000000000000e+00,
     1.0000000000000000e+00,  3.5000000000000000e+00,  -6.8750000000000000e-01, -1.5625000000000000e-01,
     2.5000000000000000e-01,  1.2500000000000000e-01,  3.8125000000000000e+00,  4.3437500000000000e+00,
     1.0000000000000000e+00,  6.5000000000000000e+00,  -6.8750000000000000e-01, 2.1875000000000000e-01,
     2.5000000000000000e-01,  -2.1250000000000000e+00, 3.8125000000000000e+00,  -5.3125000000000000e-01,
     1.0000000000000000e+01,  5.0000000000000000e+00},
    {-3.0000000000000000e+00, 1.5000000000000000e+00,  -1.5000000000000000e+00, -1.6875000000000000e+00,
     1.6875000000000000e+00,  3.0937500000000000e+00,  0.0000000000000000e+00,  -2.2500000000000000e+00,
     5.6250000000000000e-01,  -9.3750000000000000e-02, 3.7500000000000000e+00,  3.3750000000000000e+00,
     1.5000000000000000e+00,  -1.8750000000000000e-01, -5.6250000000000000e-01, -6.5625000000000000e-01,
     0.0000000000000000e+00,  1.8750000000000000e-01,  3.1875000000000000e+00,  2.3437500000000000e+00,
     3.0000000000000000e+00,  4.5000000000000000e+00,  -1.6875000000000000e+00, 1.4062500000000000e+00,
     -3.7500000000000000e+00, -3.7500000000000000e-01, -3.1875000000000000e+00, -8.4375000000000000e-01,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {6.0000000000000000e+00,  4.5000000000000000e+00,  3.7500000000000000e-01,  9.3750000000000000e-01,
     3.3750000000000000e+00,  2.5312500000000000e+00,  -1.5000000000000000e+00, -7.5000000000000000e-01,
     -3.7500000000000000e-01, 9.3750000000000000e-02,  1.5000000000000000e+00,  1.1250000000000000e+00,
     3.7500000000000000e-01,  -5.6250000000000000e-01, -3.7500000000000000e-01, -4.6875000000000000e-01,
     -3.7500000000000000e-01, -1.8750000000000000e-01, 3.7500000000000000e-01,  2.8125000000000000e-01,
     6.0000000000000000e+00,  1.5000000000000000e+00,  3.3750000000000000e+00,  8.4375000000000000e-01,
     1.5000000000000000e+00,  3.7500000000000000e-01,  3.7500000000000000e-01,  9.3750000000000000e-02,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {0.0000000000000000e+00, -1.2000000000000000e+01, 0.0000000000000000e+00, -1.2000000000000000e+01,
     0.0000000000000000e+00, 2.4375000000000000e+00,  0.0000000000000000e+00, -1.2000000000000000e+01,
     0.0000000000000000e+00, 2.4375000000000000e+00,  0.0000000000000000e+00, -1.5000000000000000e+00,
     0.0000000000000000e+00, -1.2000000000000000e+01, 0.0000000000000000e+00, 2.4375000000000000e+00,
     0.0000000000000000e+00, -1.5000000000000000e+00, 0.0000000000000000e+00, -1.8750000000000000e-01,
     0.0000000000000000e+00, -1.2000000000000000e+01, 0.0000000000000000e+00, 2.4375000000000000e+00,
     0.0000000000000000e+00, -1.5000000000000000e+00, 0.0000000000000000e+00, -1.8750000000000000e-01,
     0.0000000000000000e+00, 3.0000000000000000e+01},
    {-1.0000000000000000e+00, 1.0000000000000000e+01,  -1.0000000000000000e+00, 4.7500000000000000e+00,
     3.1250000000000000e-01,  -1.8125000000000000e+00, -1.0000000000000000e+00, -5.0000000000000000e-01,
     3.1250000000000000e-01,  -5.0000000000000000e-01, -1.0000000000000000e+00, -5.0000000000000000e-01,
     -1.0000000000000000e+00, -5.7500000000000000e+00, 3.1250000000000000e-01,  8.1250000000000000e-01,
     -1.0000000000000000e+00, -5.0000000000000000e-01, 2.9375000000000000e+00,  6.0625000000000000e+00,
     -1.0000000000000000e+00, -1.1000000000000000e+01, 3.1250000000000000e-01,  2.1250000000000000e+00,
     -1.0000000000000000e+00, -5.0000000000000000e-01, 2.9375000000000000e+00,  -3.1250000000000000e+00,
     2.0000000000000000e+01,  1.0000000000000000e+01},
    {3.0000000000000000e+00,  -6.0000000000000000e+00, 1.5000000000000000e+00,  2.2500000000000000e+00,
     -1.6875000000000000e+00, -5.6250000000000000e-01, 0.0000000000000000e+00,  4.5000000000000000e+00,
     -5.6250000000000000e-01, -7.5000000000000000e-01, 3.0000000000000000e+00,  4.5000000000000000e+00,
     -1.5000000000000000e+00, 7.5000000000000000e-01,  5.6250000000000000e-01,  -1.8750000000000000e-01,
     0.0000000000000000e+00,  -7.5000000000000000e-01, 6.9375000000000000e+00,  5.8125000000000000e+00,
     -3.0000000000000000e+00, -9.0000000000000000e+00, 1.6875000000000000e+00,  1.1250000000000000e+00,
     -3.0000000000000000e+00, 1.5000000000000000e+00,  -6.9375000000000000e+00, -1.1250000000000000e+00,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {-6.0000000000000000e+00, 0.0000000000000000e+00,  -3.7500000000000000e-01, -2.9062500000000000e+00,
     4.2187500000000000e+00,  5.0625000000000000e+00,  1.5000000000000000e+00,  7.5000000000000000e-01,
     -4.6875000000000000e-01, -6.5625000000000000e-01, 5.2500000000000000e+00,  4.5000000000000000e+00,
     -3.7500000000000000e-01, 2.5312500000000000e+00,  -4.6875000000000000e-01, 1.8750000000000000e-01,
     -1.3125000000000000e+00, -6.5625000000000000e-01, 2.1562500000000000e+00,  1.6875000000000000e+00,
     -6.0000000000000000e+00, -6.0000000000000000e+00, 4.2187500000000000e+00,  -8.4375000000000000e-01,
     5.2500000000000000e+00,  7.5000000000000000e-01,  2.1562500000000000e+00,  4.6875000000000000e-01,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {1.0000000000000000e+01,  8.0000000000000000e+00,  -1.5625000000000000e+00, -5.9375000000000000e-01,
     4.2187500000000000e+00,  3.3750000000000000e+00,  0.0000000000000000e+00,  -7.5000000000000000e-01,
     -7.8125000000000000e-01, -5.3125000000000000e-01, 1.2500000000000000e+00,  1.0000000000000000e+00,
     1.5625000000000000e+00,  9.6875000000000000e-01,  7.8125000000000000e-01,  2.5000000000000000e-01,
     0.0000000000000000e+00,  -9.3750000000000000e-02, 1.5625000000000000e-01,  1.2500000000000000e-01,
     -1.0000000000000000e+01, -2.0000000000000000e+00, -4.2187500000000000e+00, -8.4375000000000000e-01,
     -1.2500000000000000e+00, -2.5000000000000000e-01, -1.5625000000000000e-01, -3.1250000000000000e-02,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {0.0000000000000000e+00, 1.7500000000000000e+01,  0.0000000000000000e+00, 1.7500000000000000e+01,
     0.0000000000000000e+00, -2.0507812500000000e+00, 0.0000000000000000e+00, 1.7500000000000000e+01,
     0.0000000000000000e+00, -2.0507812500000000e+00, 0.0000000000000000e+00, 2.1875000000000000e+00,
     0.0000000000000000e+00, 1.7500000000000000e+01,  0.0000000000000000e+00, -2.0507812500000000e+00,
     0.0000000000000000e+00, 2.1875000000000000e+00,  0.0000000000000000e+00, -4.2382812500000000e+00,
     0.0000000000000000e+00, 1.7500000000000000e+01,  0.0000000000000000e+00, -2.0507812500000000e+00,
     0.0000000000000000e+00, 2.1875000000000000e+00,  0.0000000000000000e+00, -4.2382812500000000e+00,
     0.0000000000000000e+00, 5.2500000000000000e+01},
    {1.0000000000000000e+00,  -1.5500000000000000e+01, 1.0000000000000000e+00,  -7.5000000000000000e+00,
     2.8906250000000000e-01,  2.6289062500000000e+00,  1.0000000000000000e+00,  5.0000000000000000e-01,
     2.8906250000000000e-01,  9.7265625000000000e-01,  -3.7500000000000000e-01, -2.9375000000000000e+00,
     1.0000000000000000e+00,  8.5000000000000000e+00,  2.8906250000000000e-01,  -6.8359375000000000e-01,
     -3.7500000000000000e-01, -1.8750000000000000e-01, 4.1406250000000000e-01,  5.0664062500000000e+00,
     1.0000000000000000e+00,  1.6500000000000000e+01,  2.8906250000000000e-01,  -2.3398437500000000e+00,
     -3.7500000000000000e-01, 2.5625000000000000e+00,  4.1406250000000000e-01,  -4.6523437500000000e+00,
     3.5000000000000000e+01,  1.7500000000000000e+01},
    {-3.0000000000000000e+00, 1.1500000000000000e+01,  -1.5000000000000000e+00, -2.9375000000000000e+00,
     -2.4609375000000000e-01, -2.8535156250000000e+00, 0.0000000000000000e+00,  -7.2500000000000000e+00,
     -8.2031250000000000e-02, 8.1445312500000000e-01,  -9.3750000000000000e-01, 1.3437500000000000e+00,
     1.5000000000000000e+00,  -1.4375000000000000e+00, 8.2031250000000000e-02,  8.9648437500000000e-01,
     0.0000000000000000e+00,  -1.1406250000000000e+00, 9.6914062500000000e+00,  9.6777343750000000e+00,
     3.0000000000000000e+00,  1.4500000000000000e+01,  2.4609375000000000e-01,  -2.6074218750000000e+00,
     9.3750000000000000e-01,  2.2812500000000000e+00,  -9.6914062500000000e+00, -1.3671875000000000e-02,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {6.0000000000000000e+00,  -5.5000000000000000e+00, 3.7500000000000000e-01,  5.3125000000000000e+00,
     -1.8984375000000000e+00, 1.5820312500000000e-01,  -1.5000000000000000e+00, -7.5000000000000000e-01,
     2.1093750000000000e-01,  -6.9726562500000000e-01, 7.1250000000000000e+00,  7.5312500000000000e+00,
     3.7500000000000000e-01,  -4.9375000000000000e+00, 2.1093750000000000e-01,  9.0820312500000000e-01,
     -1.7812500000000000e+00, -8.9062500000000000e-01, 6.3515625000000000e+00,  5.2519531250000000e+00,
     6.0000000000000000e+00,  1.1500000000000000e+01,  -1.8984375000000000e+00, -2.0566406250000000e+00,
     7.1250000000000000e+00,  -4.0625000000000000e-01, 6.3515625000000000e+00,  1.0996093750000000e+00,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {-1.0000000000000000e+01, -2.5000000000000000e+00, 1.5625000000000000e+00,  -9.9609375000000000e-01,
     7.3828125000000000e+00,  7.6464843750000000e+00,  0.0000000000000000e+00,  2.8125000000000000e+00,
     -1.3671875000000000e+00, -9.0820312500000000e-01, 5.6250000000000000e+00,  4.8437500000000000e+00,
     -1.5625000000000000e+00, -2.5585937500000000e+00, 1.3671875000000000e+00,  4.5898437500000000e-01,
     0.0000000000000000e+00,  -2.9296875000000000e-01, 1.1328125000000000e+00,  9.2773437500000000e-01,
     1.0000000000000000e+01,  7.5000000000000000e+00,  -7.3828125000000000e+00, 2.6367187500000000e-01,
     -5.6250000000000000e+00, -7.8125000000000000e-01, -1.1328125000000000e+00, -2.0507812500000000e-01,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {1.5000000000000000e+01,  1.2500000000000000e+01,  -2.2265625000000000e+00, -1.8945312500000000e+00,
     4.7460937500000000e+00,  3.9550781250000000e+00,  1.8750000000000000e+00,  9.3750000000000000e-01,
     -1.7578125000000000e-01, -3.8085937500000000e-01, 9.3750000000000000e-01,  7.8125000000000000e-01,
     -2.2265625000000000e+00, -3.3203125000000000e-01, -1.7578125000000000e-01, 2.0507812500000000e-01,
     1.1718750000000000e-01,  5.8593750000000000e-02,  5.8593750000000000e-02,  4.8828125000000000e-02,
     1.5000000000000000e+01,  2.5000000000000000e+00,  4.7460937500000000e+00,  7.9101562500000000e-01,
     9.3750000000000000e-01,  1.5625000000000000e-01,  5.8593750000000000e-02,  9.7656250000000000e-03,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {0.0000000000000000e+00, -2.4000000000000000e+01, 0.0000000000000000e+00, -2.4000000000000000e+01,
     0.0000000000000000e+00, -6.9140625000000000e-01, 0.0000000000000000e+00, -2.4000000000000000e+01,
     0.0000000000000000e+00, -6.9140625000000000e-01, 0.0000000000000000e+00, 1.8750000000000000e+00,
     0.0000000000000000e+00, -2.4000000000000000e+01, 0.0000000000000000e+00, -6.9140625000000000e-01,
     0.0000000000000000e+00, 1.8750000000000000e+00,  0.0000000000000000e+00, -4.6992187500000000e+00,
     0.0000000000000000e+00, -2.4000000000000000e+01, 0.0000000000000000e+00, -6.9140625000000000e-01,
     0.0000000000000000e+00, 1.8750000000000000e+00,  0.0000000000000000e+00, -4.6992187500000000e+00,
     0.0000000000000000e+00, 8.4000000000000000e+01},
    {-1.0000000000000000e+00, 2.2000000000000000e+01,  -1.0000000000000000e+00, 1.0750000000000000e+01,
     -5.0488281250000000e-01, -3.1835937500000000e-01, -1.0000000000000000e+00, -5.0000000000000000e-01,
     -5.0488281250000000e-01, -2.7441406250000000e-01, 7.8125000000000000e-01,  -3.1250000000000000e-01,
     -1.0000000000000000e+00, -1.1750000000000000e+01, -5.0488281250000000e-01, -2.3046875000000000e-01,
     7.8125000000000000e-01,  3.9062500000000000e-01,  -1.9755859375000000e+00, 7.4804687500000000e-01,
     -1.0000000000000000e+00, -2.3000000000000000e+01, -5.0488281250000000e-01, -1.8652343750000000e-01,
     7.8125000000000000e-01,  1.0937500000000000e+00,  -1.9755859375000000e+00, -2.7236328125000000e+00,
     5.6000000000000000e+01,  2.8000000000000000e+01},
    {3.0000000000000000e+00,  -1.8000000000000000e+01, 1.5000000000000000e+00,  3.7500000000000000e+00,
     1.5029296875000000e+00,  2.3203125000000000e+00,  0.0000000000000000e+00,  1.0500000000000000e+01,
     5.0097656250000000e-01,  6.1523437500000000e-02,  -2.7187500000000000e+00, -3.3750000000000000e+00,
     -1.5000000000000000e+00, 2.2500000000000000e+00,  -5.0097656250000000e-01, -4.3945312500000000e-01,
     0.0000000000000000e+00,  3.2812500000000000e-01,  8.7041015625000000e+00,  1.1320312500000000e+01,
     -3.0000000000000000e+00, -2.1000000000000000e+01, -1.5029296875000000e+00, 8.1738281250000000e-01,
     2.7187500000000000e+00,  -6.5625000000000000e-01, -8.7041015625000000e+00, 2.6162109375000000e+00,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {-6.0000000000000000e+00, 1.2000000000000000e+01,  -3.7500000000000000e-01, -8.1562500000000000e+00,
     -2.2148437500000000e+00, -4.2714843750000000e+00, 1.5000000000000000e+00,  7.5000000000000000e-01,
     2.4609375000000000e-01,  1.0019531250000000e+00,  2.6250000000000000e+00,  5.0625000000000000e+00,
     -3.7500000000000000e-01, 7.7812500000000000e+00,  2.4609375000000000e-01,  -7.5585937500000000e-01,
     -6.5625000000000000e-01, -3.2812500000000000e-01, 1.2386718750000000e+01,  1.0998046875000000e+01,
     -6.0000000000000000e+00, -1.8000000000000000e+01, -2.2148437500000000e+00, 2.0566406250000000e+00,
     2.6250000000000000e+00,  -2.4375000000000000e+00, 1.2386718750000000e+01,  1.3886718750000000e+00,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {1.0000000000000000e+01,  -4.0000000000000000e+00, -1.5625000000000000e+00, 2.8750000000000000e+00,
     -5.2734375000000000e-01, 1.9511718750000000e+00,  0.0000000000000000e+00,  -5.2500000000000000e+00,
     9.7656250000000000e-02,  9.5703125000000000e-02,  1.0625000000000000e+01,  1.0187500000000000e+01,
     1.5625000000000000e+00,  4.4375000000000000e+00,  -9.7656250000000000e-02, -1.9531250000000000e-03,
     0.0000000000000000e+00,  -1.6406250000000000e-01, 4.1992187500000000e+00,  3.5410156250000000e+00,
     -1.0000000000000000e+01, -1.4000000000000000e+01, 5.2734375000000000e-01,  2.4785156250000000e+00,
     -1.0625000000000000e+01, -4.3750000000000000e-01, -4.1992187500000000e+00, -6.5820312500000000e-01,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {-1.5000000000000000e+01, -6.0000000000000000e+00, 2.2265625000000000e+00,  2.4785156250000000e+00,
     1.0678710937500000e+01,  1.0441406250000000e+01,  -1.8750000000000000e+00, -9.3750000000000000e-01,
     -3.9550781250000000e-01, -3.4277343750000000e-01, 5.1562500000000000e+00,  4.5000000000000000e+00,
     2.2265625000000000e+00,  -2.5195312500000000e-01, -3.9550781250000000e-01, -5.2734375000000000e-02,
     6.4453125000000000e-01,  3.2226562500000000e-01,  5.1269531250000000e-01,  4.3359375000000000e-01,
     -1.5000000000000000e+01, -9.0000000000000000e+00, 1.0678710937500000e+01,  2.3730468750000000e-01,
     5.1562500000000000e+00,  6.5625000000000000e-01,  5.1269531250000000e-01,  7.9101562500000000e-02,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {2.1000000000000000e+01,  1.8000000000000000e+01,  -5.7421875000000000e-01, -1.4003906250000000e+00,
     4.9833984375000000e+00,  4.2714843750000000e+00,  0.0000000000000000e+00,  9.3750000000000000e-01,
     4.3066406250000000e-01,  1.4941406250000000e-01,  6.5625000000000000e-01,  5.6250000000000000e-01,
     5.7421875000000000e-01,  -8.2617187500000000e-01, -4.3066406250000000e-01, -2.8125000000000000e-01,
     0.0000000000000000e+00,  2.9296875000000000e-02,  2.0507812500000000e-02,  1.7578125000000000e-02,
     -2.1000000000000000e+01, -3.0000000000000000e+00, -4.9833984375000000e+00, -7.1191406250000000e-01,
     -6.5625000000000000e-01, -9.3750000000000000e-02, -2.0507812500000000e-02, -2.9296875000000000e-03,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {0.0000000000000000e+00, 3.1500000000000000e+01,  0.0000000000000000e+00, 3.1500000000000000e+01,
     0.0000000000000000e+00, 3.0992431640625000e+00,  0.0000000000000000e+00, 3.1500000000000000e+01,
     0.0000000000000000e+00, 3.0992431640625000e+00,  0.0000000000000000e+00, -2.4609375000000000e+00,
     0.0000000000000000e+00, 3.1500000000000000e+01,  0.0000000000000000e+00, 3.0992431640625000e+00,
     0.0000000000000000e+00, -2.4609375000000000e+00, 0.0000000000000000e+00, -4.0759277343750000e-01,
     0.0000000000000000e+00, 3.1500000000000000e+01,  0.0000000000000000e+00, 3.0992431640625000e+00,
     0.0000000000000000e+00, -2.4609375000000000e+00, 0.0000000000000000e+00, -4.0759277343750000e-01,
     0.0000000000000000e+00, 1.2600000000000000e+02},
    {1.0000000000000000e+00, -2.9500000000000000e+01, 1.0000000000000000e+00,  -1.4500000000000000e+01,
     1.9848632812500000e-01, -2.7022705078125000e+00, 1.0000000000000000e+00,  5.0000000000000000e-01,
     1.9848632812500000e-01, -8.3459472656250000e-01, 3.9062500000000000e-01,  3.2421875000000000e+00,
     1.0000000000000000e+00, 1.5500000000000000e+01,  1.9848632812500000e-01,  1.0330810546875000e+00,
     3.9062500000000000e-01, 1.9531250000000000e-01,  -2.4519042968750000e+00, -4.4962158203125000e+00,
     1.0000000000000000e+00, 3.0500000000000000e+01,  1.9848632812500000e-01,  2.9007568359375000e+00,
     3.9062500000000000e-01, -2.8515625000000000e+00, -2.4519042968750000e+00, 2.0443115234375000e+00,
     8.4000000000000000e+01, 4.2000000000000000e+01},
    {-3.0000000000000000e+00, 2.5500000000000000e+01,  -1.5000000000000000e+00, -4.6875000000000000e+00,
     -9.6899414062500000e-01, 1.3480224609375000e+00,  0.0000000000000000e+00,  -1.4250000000000000e+01,
     -3.2299804687500000e-01, -9.8767089843750000e-01, 4.6875000000000000e-02,  -2.9765625000000000e+00,
     1.5000000000000000e+00,  -3.1875000000000000e+00, 3.2299804687500000e-01,  -6.6467285156250000e-01,
     0.0000000000000000e+00,  1.5117187500000000e+00,  3.4313964843750000e+00,  8.4173583984375000e+00,
     3.0000000000000000e+00,  2.8500000000000000e+01,  9.6899414062500000e-01,  2.3170166015625000e+00,
     -4.6875000000000000e-02, -3.0234375000000000e+00, -3.4313964843750000e+00, 4.9859619140625000e+00,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {6.0000000000000000e+00,  -1.9500000000000000e+01, 3.7500000000000000e-01,  1.1437500000000000e+01,
     2.8081054687500000e+00,  1.7501220703125000e+00,  -1.5000000000000000e+00, -7.5000000000000000e-01,
     -3.1201171875000000e-01, 2.2302246093750000e-01,  -4.0312500000000000e+00, -2.3671875000000000e+00,
     3.7500000000000000e-01,  -1.1062500000000000e+01, -3.1201171875000000e-01, -5.3503417968750000e-01,
     1.0078125000000000e+00,  5.0390625000000000e-01,  1.7210449218750000e+01,  1.6817504882812500e+01,
     6.0000000000000000e+00,  2.5500000000000000e+01,  2.8081054687500000e+00,  1.0579833984375000e+00,
     -4.0312500000000000e+00, -1.6640625000000000e+00, 1.7210449218750000e+01,  3.9294433593750000e-01,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {-1.0000000000000000e+01, 1.1500000000000000e+01,  1.5625000000000000e+00,  -5.0429687500000000e+00,
     -5.0756835937500000e+00, -5.9886474609375000e+00, 0.0000000000000000e+00,  8.0625000000000000e+00,
     9.3994140625000000e-01,  6.1535644531250000e-01,  8.9062500000000000e+00,  1.0476562500000000e+01,
     -1.5625000000000000e+00, -6.6054687500000000e+00, -9.3994140625000000e-01, -3.2458496093750000e-01,
     0.0000000000000000e+00,  5.8886718750000000e-01,  1.0412597656250000e+01,  9.1060791015625000e+00,
     1.0000000000000000e+01,  2.1500000000000000e+01,  5.0756835937500000e+00,  -9.1296386718750000e-01,
     -8.9062500000000000e+00, 1.5703125000000000e+00,  -1.0412597656250000e+01, -1.3065185546875000e+00,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {1.5000000000000000e+01,  -1.5000000000000000e+00, -2.2265625000000000e+00, -3.1523437500000000e+00,
     2.6696777343750000e+00,  5.1317138671875000e+00,  1.8750000000000000e+00,  9.3750000000000000e-01,
     -9.8876953125000000e-02, 7.5476074218750000e-01,  1.2421875000000000e+01,  1.1554687500000000e+01,
     -2.2265625000000000e+00, 9.2578125000000000e-01,  -9.8876953125000000e-02, -8.5363769531250000e-01,
     1.5527343750000000e+00,  7.7636718750000000e-01,  2.2888183593750000e+00,  1.9705810546875000e+00,
     1.5000000000000000e+01,  1.6500000000000000e+01,  2.6696777343750000e+00,  -2.4620361328125000e+00,
     1.2421875000000000e+01,  8.6718750000000000e-01,  2.2888183593750000e+00,  3.1823730468750000e-01,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {-2.1000000000000000e+01, -1.0500000000000000e+01, 5.7421875000000000e-01,  3.8247070312500000e+00,
     1.3704345703125000e+01,  1.3081420898437500e+01,  0.0000000000000000e+00,  -3.2812500000000000e+00,
     1.1843261718750000e+00,  6.6906738281250000e-01,  4.2656250000000000e+00,  3.7734375000000000e+00,
     -5.7421875000000000e-01, 3.2504882812500000e+00,  -1.1843261718750000e+00, -5.1525878906250000e-01,
     0.0000000000000000e+00,  1.5380859375000000e-01,  2.1020507812500000e-01,  1.8200683593750000e-01,
     2.1000000000000000e+01,  1.0500000000000000e+01,  -1.3704345703125000e+01, -6.2292480468750000e-01,
     -4.2656250000000000e+00, -4.9218750000000000e-01, -2.1020507812500000e-01, -2.8198242187500000e-02,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {2.8000000000000000e+01,  2.4500000000000000e+01,  1.9755859375000000e+00,  7.0068359375000000e-01,
     4.9833984375000000e+00,  4.3604736328125000e+00,  -2.1875000000000000e+00, -1.0937500000000000e+00,
     3.4863281250000000e-01,  3.3581542968750000e-01,  4.3750000000000000e-01,  3.8281250000000000e-01,
     1.9755859375000000e+00,  1.2749023437500000e+00,  3.4863281250000000e-01,  1.2817382812500000e-02,
     -3.4179687500000000e-02, -1.7089843750000000e-02, 6.8359375000000000e-03,  5.9814453125000000e-03,
     2.8000000000000000e+01,  3.5000000000000000e+00,  4.9833984375000000e+00,  6.2292480468750000e-01,
     4.3750000000000000e-01,  5.4687500000000000e-02,  6.8359375000000000e-03,  8.5449218750000000e-04,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {0.0000000000000000e+00, -4.0000000000000000e+01, 0.0000000000000000e+00, -4.0000000000000000e+01,
     0.0000000000000000e+00, -2.4829101562500000e+00, 0.0000000000000000e+00, -4.0000000000000000e+01,
     0.0000000000000000e+00, -2.4829101562500000e+00, 0.0000000000000000e+00, -2.1875000000000000e+00,
     0.0000000000000000e+00, -4.0000000000000000e+01, 0.0000000000000000e+00, -2.4829101562500000e+00,
     0.0000000000000000e+00, -2.1875000000000000e+00, 0.0000000000000000e+00, 4.8754882812500000e+00,
     0.0000000000000000e+00, -4.0000000000000000e+01, 0.0000000000000000e+00, -2.4829101562500000e+00,
     0.0000000000000000e+00, -2.1875000000000000e+00, 0.0000000000000000e+00, 4.8754882812500000e+00,
     0.0000000000000000e+00, 1.8000000000000000e+02},
    {-1.0000000000000000e+00, 3.8000000000000000e+01,  -1.0000000000000000e+00, 1.8750000000000000e+01,
     2.6220703125000000e-01,  3.0073242187500000e+00,  -1.0000000000000000e+00, -5.0000000000000000e-01,
     2.6220703125000000e-01,  1.0898437500000000e+00,  -6.5625000000000000e-01, 8.7500000000000000e-01,
     -1.0000000000000000e+00, -1.9750000000000000e+01, 2.6220703125000000e-01,  -8.2763671875000000e-01,
     -6.5625000000000000e-01, -3.2812500000000000e-01, -8.2275390625000000e-01, -6.5209960937500000e+00,
     -1.0000000000000000e+00, -3.9000000000000000e+01, 2.6220703125000000e-01,  -2.7451171875000000e+00,
     -6.5625000000000000e-01, -1.5312500000000000e+00, -8.2275390625000000e-01, 5.6982421875000000e+00,
     1.2000000000000000e+02,  6.0000000000000000e+01},
    {3.0000000000000000e+00,  -3.4000000000000000e+01, 1.5000000000000000e+00,  5.7500000000000000e+00,
     -4.8779296875000000e-01, -3.6079101562500000e+00, 0.0000000000000000e+00,  1.8500000000000000e+01,
     -1.6259765625000000e-01, 9.3164062500000000e-01,  2.3437500000000000e+00,  2.3125000000000000e+00,
     -1.5000000000000000e+00, 4.2500000000000000e+00,  1.6259765625000000e-01,  1.0942382812500000e+00,
     0.0000000000000000e+00,  1.5625000000000000e-02,  -3.2446289062500000e+00, 1.2426757812500000e+00,
     -3.0000000000000000e+00, -3.7000000000000000e+01, 4.8779296875000000e-01,  -3.1201171875000000e+00,
     -2.3437500000000000e+00, -3.1250000000000000e-02, 3.2446289062500000e+00,  4.4873046875000000e+00,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {-6.0000000000000000e+00, 2.8000000000000000e+01,  -3.7500000000000000e-01, -1.5156250000000000e+01,
     -1.1865234375000000e-01, 3.1245117187500000e+00,  1.5000000000000000e+00,  7.5000000000000000e-01,
     1.3183593750000000e-02,  -1.3125000000000000e+00, -3.9375000000000000e+00, -6.0000000000000000e+00,
     -3.7500000000000000e-01, 1.4781250000000000e+01,  1.3183593750000000e-02,  1.3256835937500000e+00,
     9.8437500000000000e-01,  4.9218750000000000e-01,  1.6706542968750000e+01,  1.8869628906250000e+01,
     -6.0000000000000000e+00, -3.4000000000000000e+01, -1.1865234375000000e-01, -3.2431640625000000e+00,
     -3.9375000000000000e+00, 2.0625000000000000e+00,  1.6706542968750000e+01,  -2.1630859375000000e+00,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {1.0000000000000000e+01,  -2.0000000000000000e+01, -1.5625000000000000e+00, 7.5000000000000000e+00,
     2.8344726562500000e+00,  3.2958984375000000e-01,  0.0000000000000000e+00,  -1.1250000000000000e+01,
     -5.2490234375000000e-01, -3.8085937500000000e-01, -9.3750000000000000e-01, 1.8750000000000000e+00,
     1.5625000000000000e+00,  9.0625000000000000e+00,  5.2490234375000000e-01,  1.4404296875000000e-01,
     0.0000000000000000e+00,  1.0546875000000000e+00,  1.8972167968750000e+01,  1.7375488281250000e+01,
     -1.0000000000000000e+01, -3.0000000000000000e+01, -2.8344726562500000e+00, -2.5048828125000000e+00,
     9.3750000000000000e-01,  2.8125000000000000e+00,  -1.8972167968750000e+01, -1.5966796875000000e+00,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {-1.5000000000000000e+01, 1.0000000000000000e+01,  2.2265625000000000e+00,  3.9160156250000000e+00,
     -7.7124023437500000e+00, -7.3168945312500000e+00, -1.8750000000000000e+00, -9.3750000000000000e-01,
     2.8564453125000000e-01,  3.2226562500000000e-01,  1.5468750000000000e+01,  1.5937500000000000e+01,
     2.2265625000000000e+00,  -1.6894531250000000e+00, 2.8564453125000000e-01,  -3.6621093750000000e-02,
     1.9335937500000000e+00,  9.6679687500000000e-01,  6.8627929687500000e+00,  6.0375976562500000e+00,
     -1.5000000000000000e+01, -2.5000000000000000e+01, -7.7124023437500000e+00, -3.9550781250000000e-01,
     1.5468750000000000e+01,  -4.6875000000000000e-01, 6.8627929687500000e+00,  8.2519531250000000e-01,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {2.1000000000000000e+01,  2.0000000000000000e+00,  -5.7421875000000000e-01, -6.5722656250000000e+00,
     7.4750976562500000e+00,  9.6108398437500000e+00,  0.0000000000000000e+00,  5.9375000000000000e+00,
     6.4599609375000000e-01,  8.4375000000000000e-01,  1.2468750000000000e+01,  1.1500000000000000e+01,
     5.7421875000000000e-01,  -5.9980468750000000e+00, -6.4599609375000000e-01, 1.9775390625000000e-01,
     0.0000000000000000e+00,  3.0273437500000000e-01,  1.0971679687500000e+00,  9.6142578125000000e-01,
     -2.1000000000000000e+01, -1.9000000000000000e+01, -7.4750976562500000e+00, 2.1357421875000000e+00,
     -1.2468750000000000e+01, -9.6875000000000000e-01, -1.0971679687500000e+00, -1.3574218750000000e-01,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {-2.8000000000000000e+01, -1.6000000000000000e+01, -1.9755859375000000e+00, 1.1960449218750000e+00,
     1.6196044921875000e+01,  1.5306152343750000e+01,  2.1875000000000000e+00,  1.0937500000000000e+00,
     1.1330566406250000e+00,  9.0307617187500000e-01,  3.2812500000000000e+00,  2.9375000000000000e+00,
     -1.9755859375000000e+00, -3.1716308593750000e+00, 1.1330566406250000e+00,  2.2998046875000000e-01,
     -2.5634765625000000e-01, -1.2817382812500000e-01, 8.0322265625000000e-02,  7.0800781250000000e-02,
     -2.8000000000000000e+01, -1.2000000000000000e+01, 1.6196044921875000e+01,  8.8989257812500000e-01,
     3.2812500000000000e+00,  3.4375000000000000e-01,  8.0322265625000000e-02,  9.5214843750000000e-03,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {3.6000000000000000e+01,  3.2000000000000000e+01,  2.7729492187500000e+00,  2.3742675781250000e+00,
     4.8054199218750000e+00,  4.2714843750000000e+00,  0.0000000000000000e+00,  -1.0937500000000000e+00,
     -9.0087890625000000e-02, 8.5693359375000000e-02,  2.8125000000000000e-01,  2.5000000000000000e-01,
     -2.7729492187500000e+00, -3.9868164062500000e-01, 9.0087890625000000e-02,  1.7578125000000000e-01,
     0.0000000000000000e+00,  -8.5449218750000000e-03, 2.1972656250000000e-03,  1.9531250000000000e-03,
     -3.6000000000000000e+01, -4.0000000000000000e+00, -4.8054199218750000e+00, -5.3393554687500000e-01,
     -2.8125000000000000e-01, -3.1250000000000000e-02, -2.1972656250000000e-03, -2.4414062500000000e-04,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {0.0000000000000000e+00, 4.9500000000000000e+01,  0.0000000000000000e+00, 4.9500000000000000e+01,
     0.0000000000000000e+00, -8.5954284667968750e-01, 0.0000000000000000e+00, 4.9500000000000000e+01,
     0.0000000000000000e+00, -8.5954284667968750e-01, 0.0000000000000000e+00, 2.7070312500000000e+00,
     0.0000000000000000e+00, 4.9500000000000000e+01,  0.0000000000000000e+00, -8.5954284667968750e-01,
     0.0000000000000000e+00, 2.7070312500000000e+00,  0.0000000000000000e+00, 5.7630157470703125e+00,
     0.0000000000000000e+00, 4.9500000000000000e+01,  0.0000000000000000e+00, -8.5954284667968750e-01,
     0.0000000000000000e+00, 2.7070312500000000e+00,  0.0000000000000000e+00, 5.7630157470703125e+00,
     0.0000000000000000e+00, 2.4750000000000000e+02},
    {1.0000000000000000e+00,  -4.7500000000000000e+01, 1.0000000000000000e+00,  -2.3500000000000000e+01,
     -4.1702270507812500e-01, 2.5497436523437500e-02,  1.0000000000000000e+00,  5.0000000000000000e-01,
     -4.1702270507812500e-01, -1.3050842285156250e-01, -3.8281250000000000e-01, -3.4726562500000000e+00,
     1.0000000000000000e+00,  2.4500000000000000e+01,  -4.1702270507812500e-01, -2.8651428222656250e-01,
     -3.8281250000000000e-01, -1.9140625000000000e-01, 1.3359069824218750e+00,  -3.0912017822265625e+00,
     1.0000000000000000e+00,  4.8500000000000000e+01,  -4.1702270507812500e-01, -4.4252014160156250e-01,
     -3.8281250000000000e-01, 3.0898437500000000e+00,  1.3359069824218750e+00,  4.4271087646484375e+00,
     1.6500000000000000e+02,  8.2500000000000000e+01},
    {-3.0000000000000000e+00, 4.3500000000000000e+01,  -1.5000000000000000e+00, -6.9375000000000000e+00,
     1.2705688476562500e+00,  1.6718444824218750e+00,  0.0000000000000000e+00,  -2.3250000000000000e+01,
     4.2352294921875000e-01,  1.4859008789062500e-01,  3.2812500000000000e-01,  3.7734375000000000e+00,
     1.5000000000000000e+00,  -5.4375000000000000e+00, -4.2352294921875000e-01, -2.7493286132812500e-01,
     0.0000000000000000e+00,  -1.7226562500000000e+00, -6.8270874023437500e+00, -6.4814758300781250e+00,
     3.0000000000000000e+00,  4.6500000000000000e+01,  -1.2705688476562500e+00, 4.0127563476562500e-01,
     -3.2812500000000000e-01, 3.4453125000000000e+00,  6.8270874023437500e+00,  3.4561157226562500e-01,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {6.0000000000000000e+00,  -3.7500000000000000e+01, 3.7500000000000000e-01,  1.9312500000000000e+01,
     -2.3236083984375000e+00, -3.9229431152343750e+00, -1.5000000000000000e+00, -7.5000000000000000e-01,
     2.5817871093750000e-01,  8.2369995117187500e-01,  2.1562500000000000e+00,  -6.7968750000000000e-01,
     3.7500000000000000e-01,  -1.8937500000000000e+01, 2.5817871093750000e-01,  -5.6552124023437500e-01,
     -5.3906250000000000e-01, -2.6953125000000000e-01, 9.0728759765625000e+00,  1.4027252197265625e+01,
     6.0000000000000000e+00,  4.3500000000000000e+01,  -2.3236083984375000e+00, 1.5993347167968750e+00,
     2.1562500000000000e+00,  2.8359375000000000e+00,  9.0728759765625000e+00,  -4.9543762207031250e+00,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {-1.0000000000000000e+01, 2.9500000000000000e+01,  1.5625000000000000e+00,  -1.0246093750000000e+01,
     2.4884033203125000e+00,  5.2907409667968750e+00,  0.0000000000000000e+00,  1.4812500000000000e+01,
     -4.6081542968750000e-01, -2.7261352539062500e-01, -7.9687500000000000e+00, -7.6640625000000000e+00,
     -1.5625000000000000e+00, -1.1808593750000000e+01, 4.6081542968750000e-01,  1.8820190429687500e-01,
     0.0000000000000000e+00,  1.1425781250000000e-01,  2.6150512695312500e+01,  2.5465545654296875e+01,
     1.0000000000000000e+01,  3.9500000000000000e+01,  -2.4884033203125000e+00, 2.8023376464843750e+00,
     7.9687500000000000e+00,  3.0468750000000000e-01,  -2.6150512695312500e+01, -6.8496704101562500e-01,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {1.5000000000000000e+01,  -1.9500000000000000e+01, -2.2265625000000000e+00, -4.7695312500000000e+00,
     6.6741943359375000e-01,  -2.4991149902343750e+00, 1.8750000000000000e+00,  9.3750000000000000e-01,
     -2.4719238281250000e-02, -1.0719909667968750e+00, 6.7968750000000000e+00,  9.4453125000000000e+00,
     -2.2265625000000000e+00, 2.5429687500000000e+00,  -2.4719238281250000e-02, 1.0472717285156250e+00,
     8.4960937500000000e-01,  4.2480468750000000e-01,  1.5315856933593750e+01,  1.3833892822265625e+01,
     1.5000000000000000e+01,  3.4500000000000000e+01,  6.6741943359375000e-01,  3.1665344238281250e+00,
     6.7968750000000000e+00,  -2.6484375000000000e+00, 1.5315856933593750e+01,  1.4819641113281250e+00,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {-2.1000000000000000e+01, 7.5000000000000000e+00,  5.7421875000000000e-01,  9.6430664062500000e+00,
     -8.9545440673828125e+00, -7.3916702270507812e+00, 0.0000000000000000e+00,  -8.9062500000000000e+00,
     -7.7384948730468750e-01, -2.1361541748046875e-01, 2.0261718750000000e+01,  1.9857421875000000e+01,
     -5.7421875000000000e-01, 9.0688476562500000e+00,  7.7384948730468750e-01,  5.6023406982421875e-01,
     0.0000000000000000e+00,  1.2634277343750000e-01,  3.8525848388671875e+00,  3.4240036010742188e+00,
     2.1000000000000000e+01,  2.8500000000000000e+01,  8.9545440673828125e+00,  1.5628738403320312e+00,
     -2.0261718750000000e+01, -4.0429687500000000e-01, -3.8525848388671875e+00, -4.2858123779296875e-01,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {2.8000000000000000e+01,  6.5000000000000000e+00,  1.9755859375000000e+00,  -3.3159179687500000e+00,
     1.3392883300781250e+01,  1.5022499084472656e+01,  -2.1875000000000000e+00, -1.0937500000000000e+00,
     9.3695068359375000e-01,  3.5414886474609375e-01,  1.1265625000000000e+01,  1.0384765625000000e+01,
     1.9755859375000000e+00,  5.2915039062500000e+00,  9.3695068359375000e-01,  5.8280181884765625e-01,
     -8.8012695312500000e-01, -4.4006347656250000e-01, 4.7979736328125000e-01,  4.2655181884765625e-01,
     2.8000000000000000e+01,  2.1500000000000000e+01,  1.3392883300781250e+01,  -1.6296157836914062e+00,
     1.1265625000000000e+01,  8.8085937500000000e-01,  4.7979736328125000e-01,  5.3245544433593750e-02,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {-3.6000000000000000e+01, -2.2500000000000000e+01, -2.7729492187500000e+00, -3.0738372802734375e+00,
     1.8020324707031250e+01,  1.6969139099121094e+01,  0.0000000000000000e+00,  3.6914062500000000e+00,
     -3.3782958984375000e-01, 6.1729431152343750e-02,  2.3906250000000000e+00,  2.1621093750000000e+00,
     2.7729492187500000e+00,  -3.0088806152343750e-01, 3.3782958984375000e-01,  3.9955902099609375e-01,
     0.0000000000000000e+00,  -6.2484741210937500e-02, 2.9113769531250000e-02,  2.6023864746093750e-02,
     3.6000000000000000e+01,  1.3500000000000000e+01,  -1.8020324707031250e+01, -1.0511856079101562e+00,
     -2.3906250000000000e+00, -2.2851562500000000e-01, -2.9113769531250000e-02, -3.0899047851562500e-03,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {4.5000000000000000e+01,  4.0500000000000000e+01,  7.2372436523437500e-01,  1.7483367919921875e+00,
     4.5050811767578125e+00,  4.0545730590820312e+00,  2.4609375000000000e+00,  1.2304687500000000e+00,
     -2.6847839355468750e-01, -1.6802215576171875e-01, 1.7578125000000000e-01,  1.5820312500000000e-01,
     7.2372436523437500e-01,  -1.0246124267578125e+00, -2.6847839355468750e-01, -1.0045623779296875e-01,
     9.6130371093750000e-03,  4.8065185546875000e-03,  6.8664550781250000e-04,  6.1798095703125000e-04,
     4.5000000000000000e+01,  4.5000000000000000e+00,  4.5050811767578125e+00,  4.5050811767578125e-01,
     1.7578125000000000e-01,  1.7578125000000000e-02,  6.8664550781250000e-04,  6.8664550781250000e-05,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {0.0000000000000000e+00, -6.0000000000000000e+01, 0.0000000000000000e+00, -6.0000000000000000e+01,
     0.0000000000000000e+00, 3.6421966552734375e+00,  0.0000000000000000e+00, -6.0000000000000000e+01,
     0.0000000000000000e+00, 3.6421966552734375e+00,  0.0000000000000000e+00, 2.4609375000000000e+00,
     0.0000000000000000e+00, -6.0000000000000000e+01, 0.0000000000000000e+00, 3.6421966552734375e+00,
     0.0000000000000000e+00, 2.4609375000000000e+00,  0.0000000000000000e+00, 8.1550598144531250e-01,
     0.0000000000000000e+00, -6.0000000000000000e+01, 0.0000000000000000e+00, 3.6421966552734375e+00,
     0.0000000000000000e+00, 2.4609375000000000e+00,  0.0000000000000000e+00, 8.1550598144531250e-01,
     0.0000000000000000e+00, 3.3000000000000000e+02},
    {-1.0000000000000000e+00, 5.8000000000000000e+01,  -1.0000000000000000e+00, 2.8750000000000000e+01,
     1.5100860595703125e-01,  -3.3401794433593750e+00, -1.0000000000000000e+00, -5.0000000000000000e-01,
     1.5100860595703125e-01,  -1.0630569458007812e+00, 5.7421875000000000e-01,  -1.3125000000000000e+00,
     -1.0000000000000000e+00, -2.9750000000000000e+01, 1.5100860595703125e-01,  1.2140655517578125e+00,
     5.7421875000000000e-01,  2.8710937500000000e-01,  2.0983505249023438e+00,  3.3811950683593750e+00,
     -1.0000000000000000e+00, -5.9000000000000000e+01, 1.5100860595703125e-01,  3.4911880493164062e+00,
     5.7421875000000000e-01,  1.8867187500000000e+00,  2.0983505249023438e+00,  -1.2828445434570312e+00,
     2.2000000000000000e+02,  1.1000000000000000e+02},
    {3.0000000000000000e+00,  -5.4000000000000000e+01, 1.5000000000000000e+00,  8.2500000000000000e+00,
     -6.8657684326171875e-01, 2.3858184814453125e+00,  0.0000000000000000e+00,  2.8500000000000000e+01,
     -2.2885894775390625e-01, -1.1767044067382812e+00, -2.0507812500000000e+00, -1.4765625000000000e+00,
     -1.5000000000000000e+00, 6.7500000000000000e+00,  2.2885894775390625e-01,  -9.4784545898437500e-01,
     0.0000000000000000e+00,  -2.8710937500000000e-01, -4.8599624633789062e+00, -9.6219635009765625e+00,
     -3.0000000000000000e+00, -5.7000000000000000e+01, 6.8657684326171875e-01,  3.0723953247070312e+00,
     2.0507812500000000e+00,  5.7421875000000000e-01,  4.8599624633789062e+00,  -4.7620010375976562e+00,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {-6.0000000000000000e+00, 4.8000000000000000e+01,  -3.7500000000000000e-01, -2.3906250000000000e+01,
     1.9824829101562500e+00,  -2.0022583007812500e-01, 1.5000000000000000e+00,  7.5000000000000000e-01,
     -2.2027587890625000e-01, 7.4240112304687500e-01,  4.0312500000000000e+00,  5.4843750000000000e+00,
     -3.7500000000000000e-01, 2.3531250000000000e+01,  -2.2027587890625000e-01, -9.6267700195312500e-01,
     -1.0078125000000000e+00, -5.0390625000000000e-01, -2.5881958007812500e+00, 2.9310607910156250e+00,
     -6.0000000000000000e+00, -5.4000000000000000e+01, 1.9824829101562500e+00,  2.1827087402343750e+00,
     4.0312500000000000e+00,  -1.4531250000000000e+00, -2.5881958007812500e+00, -5.5192565917968750e+00,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {1.0000000000000000e+01,  -4.0000000000000000e+01, -1.5625000000000000e+00, 1.3281250000000000e+01,
     -4.1610717773437500e+00, -3.5142517089843750e+00, 0.0000000000000000e+00,  -1.8750000000000000e+01,
     7.7056884765625000e-01,  5.2169799804687500e-01,  -2.9687500000000000e+00, -6.1718750000000000e+00,
     1.5625000000000000e+00,  1.4843750000000000e+01,  -7.7056884765625000e-01, -2.4887084960937500e-01,
     0.0000000000000000e+00,  -1.2011718750000000e+00, 2.6586608886718750e+01,  2.8361053466796875e+01,
     -1.0000000000000000e+01, -5.0000000000000000e+01, 4.1610717773437500e+00,  6.4682006835937500e-01,
     2.9687500000000000e+00,  -3.2031250000000000e+00, -2.6586608886718750e+01, 1.7744445800781250e+00,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {-1.5000000000000000e+01, 3.0000000000000000e+01,  2.2265625000000000e+00,  5.7128906250000000e+00,
     6.0484886169433594e+00,  7.4435806274414062e+00,  -1.8750000000000000e+00, -9.3750000000000000e-01,
     -2.2401809692382812e-01, 3.1568527221679688e-01,  -7.4121093750000000e+00, -5.0976562500000000e+00,
     2.2265625000000000e+00,  -3.4863281250000000e+00, -2.2401809692382812e-01, -5.3970336914062500e-01,
     -9.2651367187500000e-01, -4.6325683593750000e-01, 2.6605396270751953e+01,  2.4834709167480469e+01,
     -1.5000000000000000e+01, -4.5000000000000000e+01, 6.0484886169433594e+00,  -1.3950920104980469e+00,
     -7.4121093750000000e+00, -2.3144531250000000e+00, 2.6605396270751953e+01,  1.7706871032714844e+00,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {2.1000000000000000e+01,  -1.8000000000000000e+01, -5.7421875000000000e-01, -1.3037109375000000e+01,
     -3.7180824279785156e+00, -6.7409362792968750e+00, 0.0000000000000000e+00,  1.2187500000000000e+01,
     -3.2131576538085938e-01, -7.9887771606445312e-01, 1.6775390625000000e+01,  1.8492187500000000e+01,
     5.7421875000000000e-01,  -1.2462890625000000e+01, 3.2131576538085938e-01,  -4.7756195068359375e-01,
     0.0000000000000000e+00,  -5.3649902343750000e-01, 1.0132221221923828e+01,  9.1573791503906250e+00,
     -2.1000000000000000e+01, -3.9000000000000000e+01, 3.7180824279785156e+00,  -3.0228538513183594e+00,
     -1.6775390625000000e+01, 1.7167968750000000e+00,  -1.0132221221923828e+01, -9.7484207153320312e-01,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {-2.8000000000000000e+01, 4.0000000000000000e+00,  -1.9755859375000000e+00, 5.6589355468750000e+00,
     -7.9422912597656250e+00, -5.5228958129882812e+00, 2.1875000000000000e+00,  1.0937500000000000e+00,
     -5.5563354492187500e-01, -7.7199554443359375e-01, 2.2421875000000000e+01,  2.1511718750000000e+01,
     -1.9755859375000000e+00, -7.6345214843750000e+00, -5.5563354492187500e-01, 2.1636199951171875e-01,
     -1.7517089843750000e+00, -8.7585449218750000e-01, 1.9292297363281250e+00,  1.7322158813476562e+00,
     -2.8000000000000000e+01, -3.2000000000000000e+01, -7.9422912597656250e+00, -2.4193954467773438e+00,
     2.2421875000000000e+01,  9.1015625000000000e-01,  1.9292297363281250e+00,  1.9701385498046875e-01,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {3.6000000000000000e+01,  1.2000000000000000e+01,  2.7729492187500000e+00,  3.8470458984375000e+00,
     1.9822357177734375e+01,  2.0873542785644531e+01,  0.0000000000000000e+00,  -6.5625000000000000e+00,
     -3.7161254882812500e-01, -5.3469085693359375e-01, 9.4218750000000000e+00,  8.7070312500000000e+00,
     -2.7729492187500000e+00, 1.0740966796875000e+00,  3.7161254882812500e-01,  -1.6307830810546875e-01,
     0.0000000000000000e+00,  -1.9546508789062500e-01, 1.9583129882812500e-01,  1.7617034912109375e-01,
     -3.6000000000000000e+01, -2.4000000000000000e+01, -1.9822357177734375e+01, 1.0511856079101562e+00,
     -9.4218750000000000e+00, -7.1484375000000000e-01, -1.9583129882812500e-01, -1.9660949707031250e-02,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {-4.5000000000000000e+01, -3.0000000000000000e+01, -7.2372436523437500e-01, -4.5612716674804688e+00,
     1.9146595001220703e+01,  1.8020324707031250e+01,  -2.4609375000000000e+00, -1.2304687500000000e+00,
     -1.1410331726074219e+00, -7.3328018188476562e-01, 1.6699218750000000e+00,  1.5234375000000000e+00,
     -7.2372436523437500e-01, 3.8375473022460938e+00,  -1.1410331726074219e+00, -4.0775299072265625e-01,
     9.1323852539062500e-02,  4.5661926269531250e-02,  1.0128021240234375e-02,  9.1552734375000000e-03,
     -4.5000000000000000e+01, -1.5000000000000000e+01, 1.9146595001220703e+01,  1.1262702941894531e+00,
     1.6699218750000000e+00,  1.4648437500000000e-01,  1.0128021240234375e-02,  9.7274780273437500e-04,
     0.0000000000000000e+00,  0.0000000000000000e+00},
    {5.5000000000000000e+01,  5.0000000000000000e+01,  -2.3171234130859375e+00, -7.9669952392578125e-01,
     4.1296577453613281e+00,  3.7542343139648438e+00,  0.0000000000000000e+00,  1.2304687500000000e+00,
     -8.5391998291015625e-02, -1.4337539672851562e-01, 1.0742187500000000e-01,  9.7656250000000000e-02,
     2.3171234130859375e+00,  1.5204238891601562e+00,  8.5391998291015625e-02,  -5.7983398437500000e-02,
     0.0000000000000000e+00,  2.4032592773437500e-03,  2.0980834960937500e-04,  1.9073486328125000e-04,
     -5.5000000000000000e+01, -5.0000000000000000e+00, -4.1296577453613281e+00, -3.7542343139648438e-01,
     -1.0742187500000000e-01, -9.7656250000000000e-03, -2.0980834960937500e-04, -1.9073486328125000e-05,
     0.0000000000000000e+00,  0.0000000000000000e+00}};

int main() {
    using Utilities::almost_equal;

    AlignedVector<Point<2>> points(15);

    points[0][0]  = 1.0000000000000000e+00;
    points[0][1]  = -1.0000000000000000e+00;
    points[1][0]  = 5.0000000000000000e-01;
    points[1][1]  = -1.0000000000000000e+00;
    points[2][0]  = 5.0000000000000000e-01;
    points[2][1]  = -5.0000000000000000e-01;
    points[3][0]  = 0.0000000000000000e+00;
    points[3][1]  = -1.0000000000000000e+00;
    points[4][0]  = 0.0000000000000000e+00;
    points[4][1]  = -5.0000000000000000e-01;
    points[5][0]  = 0.0000000000000000e+00;
    points[5][1]  = 0.0000000000000000e+00;
    points[6][0]  = -5.0000000000000000e-01;
    points[6][1]  = -1.0000000000000000e+00;
    points[7][0]  = -5.0000000000000000e-01;
    points[7][1]  = -5.0000000000000000e-01;
    points[8][0]  = -5.0000000000000000e-01;
    points[8][1]  = 0.0000000000000000e+00;
    points[9][0]  = -5.0000000000000000e-01;
    points[9][1]  = 5.0000000000000000e-01;
    points[10][0] = -1.0000000000000000e+00;
    points[10][1] = -1.0000000000000000e+00;
    points[11][0] = -1.0000000000000000e+00;
    points[11][1] = -5.0000000000000000e-01;
    points[12][0] = -1.0000000000000000e+00;
    points[12][1] = 0.0000000000000000e+00;
    points[13][0] = -1.0000000000000000e+00;
    points[13][1] = 5.0000000000000000e-01;
    points[14][0] = -1.0000000000000000e+00;
    points[14][1] = 1.0000000000000000e+00;

    auto is_normal_or_zero = [](double a) -> bool { return (std::isnormal(a) || (a == 0)); };

    Basis::Dubiner_2D basis;
    bool error_found = false;

    DynMatrix<double> my_evals                 = basis.GetPhi(10, points);
    std::array<DynMatrix<double>, 2> my_Devals = basis.GetDPhi(10, points);

    for (uint dof = 0; dof < 66; ++dof) {
        // Check the evaluations of the Dubiner polynomials
        for (uint pt = 0; pt < 15; ++pt) {
            if (!is_normal_or_zero(my_evals(dof, pt))) {
                std::cerr << "Error dof(" << dof << "): the true value = " << true_vals[dof][pt]
                          << " your computed value  = " << my_evals(dof, pt) << std::endl;

                error_found = true;
            }
        }

        for (uint pt = 0; pt < 15; ++pt) {
            if (!almost_equal(true_vals[dof][pt], my_evals(dof, pt))) {
                std::cerr << "Error dof(" << dof << "): the true value = " << true_vals[dof][pt]
                          << " your computed value  = " << my_evals(dof, pt) << std::endl;

                error_found = true;
            }
        }

        // Check the Gradient evaluations of the Dubiner polynomials
        for (int pt = 0; pt < 15; ++pt) {
            if (!is_normal_or_zero(my_Devals[LocalCoordTri::z1](dof, pt)) ||
                !is_normal_or_zero(my_Devals[LocalCoordTri::z2](dof, pt))) {
                std::cerr << "Error in Gradient dof(" << dof << "): the true value = (" << true_Dvals[dof][2 * pt]
                          << ", " << true_Dvals[dof][2 * pt + 1] << ") your computed value  = ("
                          << my_Devals[LocalCoordTri::z1](dof, pt) << ", " << my_Devals[LocalCoordTri::z2](dof, pt)
                          << ")\n";

                error_found = true;
            }
        }

        for (int pt = 0; pt < 15; ++pt) {
            if (!almost_equal(true_Dvals[dof][2 * pt], my_Devals[LocalCoordTri::z1](dof, pt), 1000) ||
                !almost_equal(true_Dvals[dof][2 * pt + 1], my_Devals[LocalCoordTri::z2](dof, pt), 1000)) {
                std::cerr << "Error in Gradient dof(" << dof << pt << "): the true value = (" << std::setprecision(14)
                          << true_Dvals[dof][2 * pt] << ", " << true_Dvals[dof][2 * pt + 1]
                          << ") your computed value  = (" << my_Devals[LocalCoordTri::z1](dof, pt) << ", "
                          << my_Devals[LocalCoordTri::z2](dof, pt) << ")\n";

                error_found = true;
            }
        }
    }

    if (error_found) {
        return 1;
    }
    return 0;
}